CREATE FUNCTION [dbo].[GenEAN] (@elotag tinyint = NULL, @ertek int)
RETURNS VARCHAR(13)
AS
BEGIN
    DECLARE @chk_digit int, @chk int, @barcode varchar(12)

    DECLARE @num TABLE (num int)

	--EAN 13
	IF @elotag IS NULL
		SET @elotag = ''

	SET @barcode = CAST(@elotag AS varchar) + RIGHT('00000000000' + CAST(@ertek AS varchar), 12 - LEN(@elotag))

    INSERT INTO @num 
    SELECT 1 UNION ALL SELECT 2 UNION ALL SELECT 3 UNION ALL SELECT 4 UNION ALL SELECT 5 UNION ALL SELECT 6 UNION ALL
    SELECT 7 UNION ALL SELECT 8 UNION ALL SELECT 9 UNION ALL SELECT 10 UNION ALL SELECT 11 UNION ALL SELECT 12

    SELECT @chk_digit = SUM(CONVERT(int, SUBSTRING(@barcode, LEN(@barcode) - num + 1, 1)) * CASE WHEN num % 2 = 1 THEN 3 ELSE 1 END)
    FROM @num
    WHERE num <= LEN(@barcode)

    SELECT @chk_digit = (10 - (@chk_digit % 10)) % 10

    RETURN @barcode + CHAR(ASCII('0') + @chk_digit)
END