CREATE PROCEDURE [dbo].[sp_doc_create] @dokumenTxt text, @docSorID int, @creUser smallint
AS
BEGIN
	DECLARE @docDirectory varchar(200), @path varchar(150), @mappankentFajlDb int = 1000, @ext varchar(5)

	--Szerver bels dokumentum knyvtra
	SELECT @docDirectory = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 190

	IF @docDirectory = ''
	BEGIN
		SELECT -1 AS hiba, 'Nincs megadva a "Szerver bels dokumentum knyvtra" rendszerparamter' AS hibaszov
		RETURN
	END

	SELECT @ext = DocExtens FROM DOCSOR WHERE DocSorID = @docSorID

	IF RIGHT(@docDirectory, 1) <> '\'
		SET @docDirectory = @docDirectory + '\'

	SET @path = @docDirectory + DB_NAME() + '\' + CAST((CEILING(CONVERT(decimal, @docSorID) / @mappankentFajlDb) * @mappankentFajlDb) AS varchar) + '\' + CONVERT(varchar, @docSorID) + '.' + @ext

	IF OBJECT_ID('tempdb..#DocInsertResult') IS NOT NULL
		DROP TABLE #DocInsertResult;

	CREATE TABLE #DocInsertResult(hiba smallint, hibaszov varchar(200))

	INSERT #DocInsertResult (hiba, hibaszov)
	EXEC sp_fajl_create @dokumenTxt, @path, @creUser

	--nincs hiba, akkor Fajlba bejegyzs
	IF((SELECT hiba FROM #DocInsertResult) = 0)
	BEGIN
		UPDATE DOCSOR SET Fajlba = GETDATE() WHERE DocSorID = @docSorID
	END

	SELECT * FROM #DocInsertResult
END