CREATE PROCEDURE [dbo].[sp_docsor_insert] @docID int, @filenev varchar(100), @stationID tinyint, @docExtens varchar(5), @mit varchar(100), @mire varchar(100)
AS
BEGIN
DECLARE @LotsOfText VARCHAR(MAX), @hossz int, @command nvarchar(500), @file nvarchar(150), @docDirectory varchar(200), @docSorID int, @result int
SET @file = REPLACE(@filenev, @mit, @mire)

EXEC xp_fileExist @file, @hossz OUTPUT
IF @hossz = 0
	SELECT -2 AS ok
ELSE
BEGIN  
	SET @command = 'SELECT @LotsOfText = BulkColumn FROM OPENROWSET(BULK '''+REPLACE(@file,'''','''''')+''', SINGLE_BLOB) AS x'
	EXEC sp_executeSql @command, N'@LotsOfText varchar(max) output ', @LotsOfText OUTPUT
	SET @hossz = LEN(@LotsOfText)	

	IF @hossz IS NULL
       SELECT -1 AS ok
	ELSE
	BEGIN
		--Szerver bels dokumentum knyvtra
		SELECT @docDirectory = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 190

        INSERT INTO DOCSOR (DocID, dokumentxt, Filenev, StationID, hossz, DocExtens)
					VALUES (@docID, (CASE WHEN @docDirectory <> '' THEN NULL ELSE @LotsOfText END), @filenev, @stationID, @hossz, @docExtens)

		--Fjlszerver
		IF(@docDirectory <> '')
		BEGIN
			SET @docSorID = @@IDENTITY

			DECLARE @path varchar(150), @mappankentFajlDb int = 1000

			IF RIGHT(@docDirectory, 1) <> '\'
				SET @docDirectory = @docDirectory + '\'

			SET @path = @docDirectory + DB_NAME() + '\' + CAST((CEILING(CONVERT(decimal, @docSorID) / @mappankentFajlDb) * @mappankentFajlDb) AS varchar) + '\' + CONVERT(varchar, @docSorID) + '.' + @docExtens

			IF OBJECT_ID('tempdb..#DocInsertResult') IS NOT NULL
				DROP TABLE #DocInsertResult;

			CREATE TABLE #DocInsertResult(hiba smallint, hibaszov varchar(200))

			INSERT #DocInsertResult (hiba, hibaszov)
			EXEC sp_fajl_create @LotsOfText, @path, 255

			--nincs hiba, akkor Fajlba bejegyzs
			IF((SELECT hiba FROM #DocInsertResult) = 0)
			BEGIN
				UPDATE DOCSOR SET Fajlba = GETDATE() WHERE DocSorID = @docSorID
				SELECT 1 AS ok
			END
			ELSE
				SELECT -3 AS ok
		END
		ELSE
			SELECT 1 AS ok
	END
END    
END
