CREATE PROCEDURE [dbo].[sp_kedeny_gcmsync_napi]
AS 
BEGIN
BEGIN TRY

	SET NOCOUNT ON;

	DECLARE @kedenyID int, @kedenyekID smallint, @kukauritID smallint, @szolgID smallint, @RFCHIPID int, @szlaMod char(1), @korrekcio numeric(5,4), @tol date, @ig date, @statusz smallint,
			@dKedenyID int, @dKedenyekID smallint, @dKukauritID smallint, @dSzolgID smallint, @dRFCHIPID int, @dSzlaMod char(1), @dKorrekcio numeric(5,4), @dTol date, @dIg date, @dStatusz smallint,
			@webUserID smallint, @vevoID int, @szghelyID int, @varosID smallint, @utcaID smallint, @koztertpID smallint
			
	IF DB_NAME() LIKE '%teszt%'
		RETURN

	--WEB user azonost
	SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

	IF @webUserID = ''
		RETURN

	IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') = 0
		RETURN
	
	IF CURSOR_STATUS('global','KedenyCursor')>=-1
	BEGIN
		CLOSE KedenyCursor
		DEALLOCATE KedenyCursor
	END

	DECLARE KedenyCursor CURSOR FOR

	SELECT KEDENY.KEdenyID, KEDENY.Kedenyekid, KEDENY.kukauritID, KEDENY.SzolgID, 
		   KEDENY.RFCHIPID, KEDENY.Szlamod, KEDENY.Korrekcio, KEDENY.Tol, KEDENY.Ig,
		   KEDENY.Statusz, SZGHELY.VevoID, SZGHELY.SzghelyID, VAROSOK.VarosID, UTCAK.UtcaID, UTCAK.KoztertpID
	FROM KEDENY
		 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = KEDENY.SzghelyiD
		 INNER JOIN VAROSOK ON VAROSOK.VarosID = SZGHELY.SzgVarosID
		 LEFT JOIN UTCAK ON UTCAK.UtcaID = ISNULL(SZGHELY.UrUtcaID, SZGHELY.SzgUtcaID)
		 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
	WHERE KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND (KEDENY.Tol = CAST(GETDATE() AS date) OR KEDENY.Ig = CAST(DATEADD(DAY,-1,GETDATE()) AS date))

	OPEN KedenyCursor

	BEGIN TRY
		BEGIN TRAN

		FETCH NEXT FROM KedenyCursor INTO 
			@kedenyID, @kedenyekID, @kukauritID, @szolgID,
			@RFCHIPID, @szlaMod, @korrekcio, @tol, @ig,
			@statusz, @vevoID, @szghelyID, @varosID, @utcaID, @koztertpID
		WHILE @@FETCH_STATUS = 0
		BEGIN
			--Trls
			IF @Ig = CAST(DATEADD(DAY,-1,GETDATE()) AS date)
			BEGIN
				 SET @dKedenyID = @kedenyID
				 SET @dKedenyekID = @kedenyekID
				 SET @dKukauritID = @kukauritID
				 SET @dSzolgID = @szolgID
				 SET @dRFCHIPID = @RFCHIPID
				 SET @dSzlaMod = @szlaMod
				 SET @dKorrekcio = @korrekcio
				 SET @dTol = @tol
				 SET @dIg = @ig
				 SET @dStatusz = @statusz

				 SET @kedenyID = NULL
				 SET @kedenyekID = NULL
				 SET @kukauritID = NULL
				 SET @szolgID = NULL
				 SET @RFCHIPID = NULL
				 SET @szlaMod = NULL
				 SET @korrekcio = NULL
				 SET @tol = NULL
				 SET @ig = NULL
				 SET @statusz = NULL
			END

			exec sp_kedeny_gcmsync 
				 @kedenyID, @kedenyekID, @kukauritID, @szolgID, @RFCHIPID, @szlaMod, @korrekcio, @tol, @ig, @statusz, 0,
				 @dKedenyID, @dKedenyekID, @dKukauritID, @dSzolgID, @dRFCHIPID, @dSzlaMod, @dKorrekcio, @dTol, @dIg, @dStatusz, 0,
				 @vevoID, @szghelyID, @varosID, @utcaID, @koztertpID, @webUserID, 1

			FETCH NEXT FROM KedenyCursor INTO 
				@kedenyID, @kedenyekID, @kukauritID, @szolgID,
				@RFCHIPID, @szlaMod, @korrekcio, @tol, @ig,
				@statusz, @vevoID, @szghelyID, @varosID, @utcaID, @koztertpID
		END

		CLOSE KedenyCursor
		DEALLOCATE KedenyCursor

		COMMIT

	END TRY
	BEGIN CATCH
		ROLLBACK
	END CATCH

END TRY
BEGIN CATCH
END CATCH
END