CREATE PROCEDURE [dbo].[sp_keszlet_mozgat] @kiRaktarID tinyint, @forrasRaktarPID int, @beRaktarID tinyint, @celRaktarPID int, @cikkID int, @mennyi numeric(10,3), @userID smallint, @sorID int = NULL
AS 
BEGIN
	SET NOCOUNT ON;

	DECLARE
	@kiMozgnemID smallint, @kiBizfejID int, @kiTarhelyes bit, @kiRaktarTip char,
	@beMozgnemID smallint, @beBizfejID int, @beTarhelyes bit, @beRaktarTip char,
	@bizsorID int, @megszunt bit, @afaID tinyint, @meID tinyint, @napiAthely bit,
	@hiba int, @hibaszov varchar(MAX)

	SELECT @kiMozgnemID=MOZGNEM.MozgnemID
	FROM MOZGNEM
		 INNER JOIN EVEK ON EVEK.EvekID=MOZGNEM.KonyvEv
	WHERE MOZGNEM.SpecKod='A' AND EVEK.Ev=YEAR(GETDATE()) AND LTRIM(RTRIM(ISNULL(MOZGNEM.Raktarak,''))) = ''

	IF @kiMozgnemID IS NULL
	BEGIN
		SELECT -1 AS hiba, 'Nem tallhat raktrkzi ki mozgs az aktulis vben' AS hibaszov
		RETURN
	END

	SELECT @beMozgnemID=MOZGNEM.MozgnemID
	FROM MOZGNEM
		 INNER JOIN EVEK ON EVEK.EvekID=MOZGNEM.KonyvEv
	WHERE MOZGNEM.SpecKod='B' AND EVEK.Ev=YEAR(GETDATE()) AND LTRIM(RTRIM(ISNULL(MOZGNEM.Raktarak,''))) = ''

	IF @beMozgnemID IS NULL
	BEGIN
		SELECT -1 AS hiba, 'Nem tallhat raktrkzi be mozgs az aktulis vben' AS hibaszov
		RETURN
	END

	--Ha van trhely is megadva
	IF @forrasRaktarPID IS NOT NULL
	BEGIN
		SELECT @kiRaktarTip=RAKTAR.RaktarTip, @megszunt=ISNULL(RAKTAR.Megszunt,0), @kiTarhelyes=ISNULL(RAKTAR.Tarhelyes,0)
		FROM RAKTARP
			 INNER JOIN RAKTAR ON RAKTAR.RaktarID = RAKTARP.RaktarID
		WHERE RAKTARP.RaktarPID=@forrasRaktarPID AND RAKTAR.RaktarID=@kiRaktarID

		IF @megszunt IS NULL
		BEGIN
			SELECT -1 AS hiba, 'Nem azonosthat raktr' AS hibaszov
			RETURN
		END

		--Nem trhelyes
		IF @kiTarhelyes=0
		BEGIN
			SELECT -1 AS hiba, 'A forrs raktr nem trhely kezelses, nem adhat meg trhely' AS hibaszov
			RETURN
		END
	END
	ELSE
	BEGIN
		SELECT @kiRaktarTip=RaktarTip, @megszunt=ISNULL(Megszunt,0), @kiTarhelyes=ISNULL(Tarhelyes,0)
		FROM RAKTAR
		WHERE RaktarID=@kiRaktarID

		IF @megszunt IS NULL
		BEGIN
			SELECT -1 AS hiba, 'Nem azonosthat raktr' AS hibaszov
			RETURN
		END

		--Trhelyes
		IF @kiTarhelyes=1
		BEGIN
			SELECT -1 AS hiba, 'A forrs raktr trhely kezelses, nem adott meg trhelyet' AS hibaszov
			RETURN
		END
	END

	IF @kiRaktarTip='Z'
	BEGIN
		SELECT -1 AS hiba, 'Zrt raktr' AS hibaszov
		RETURN
	END

	IF @megszunt=1
	BEGIN
		SELECT -1 AS hiba, 'Megsznt raktr' AS hibaszov
		RETURN
	END

	--Ha van trhely is megadva
	IF @celRaktarPID IS NOT NULL
	BEGIN
		SELECT @beRaktarTip=RAKTAR.RaktarTip, @megszunt=ISNULL(RAKTAR.Megszunt,0), @beTarhelyes=ISNULL(RAKTAR.Tarhelyes,0)
		FROM RAKTARP
			 INNER JOIN RAKTAR ON RAKTAR.RaktarID = RAKTARP.RaktarID
		WHERE RAKTARP.RaktarPID=@celRaktarPID AND RAKTAR.RaktarID=@beRaktarID

		IF @megszunt IS NULL
		BEGIN
			SELECT -1 AS hiba, 'Nem azonosthat raktr' AS hibaszov
			RETURN
		END

		--Nem trhelyes
		IF @beTarhelyes=0
		BEGIN
			SELECT -1 AS hiba, 'A cl raktr nem trhely kezelses, nem adhat meg trhely' AS hibaszov
			RETURN
		END
	END
	ELSE
	BEGIN
		SELECT @beRaktarTip=RaktarTip, @megszunt=ISNULL(Megszunt,0), @beTarhelyes=ISNULL(Tarhelyes,0)
		FROM RAKTAR
		WHERE RAKTAR.RaktarID=@beRaktarID

		IF @megszunt IS NULL
		BEGIN
			SELECT -1 AS hiba, 'Nem azonosthat raktr' AS hibaszov
			RETURN
		END

		--Trhelyes
		IF @beTarhelyes=1
		BEGIN
			SELECT -1 AS hiba, 'A cl raktr trhely kezelses, nem adott meg trhelyet' AS hibaszov
			RETURN
		END
	END

	IF @beRaktarTip='Z'
	BEGIN
		SELECT -1 AS hiba, 'Zrt raktr' AS hibaszov
		RETURN
	END

	IF @megszunt=1
	BEGIN
		SELECT -1 AS hiba, 'Megsznt raktr' AS hibaszov
		RETURN
	END

	SELECT @megszunt=ISNULL(CIKK.Megszunt, 0), @afaID=CIKK.AfaID, @meID=CIKK.MeID FROM CIKK WHERE CikkID=@cikkID

	IF @megszunt=1
	BEGIN
		SELECT -1 AS hiba, 'Megsznt cikk' AS hibaszov
		RETURN
	END

	BEGIN TRY
		BEGIN TRAN

		IF @beRaktarTip <> 'J' AND @kiRaktarTip <> 'J'
			SET @napiAthely = 1;

		IF @kiRaktarTip <> 'J'
		BEGIN
			SELECT @kiBizfejID=BIZFEJ.BizfejID
			FROM BIZFEJ
				 INNER JOIN BIZSOR ON BIZSOR.BizfejID = BIZFEJ.BizfejID
			WHERE BIZFEJ.MozgnemID=@kiMozgnemID AND BIZFEJ.NapiAthely=1 AND BIZFEJ.Kelt=CAST(GETDATE() AS DATE) AND BIZSOR.RaktarID=@kiRaktarID AND BIZSOR.CelRaktar=@beRaktarID
		END

		IF @kiBizfejID IS NULL
		BEGIN
			INSERT INTO BIZFEJ (Kelt,mozgnemID,DevizaID,Statusz,NapiAthely,CreUser) 
						VALUES (GETDATE(),@kiMozgnemID,1,'',@napiAthely,@userID)

			SET @kiBizfejID=SCOPE_IDENTITY()
		END

		IF @beRaktarTip <> 'J'
		BEGIN
			SELECT @beBizfejID=BIZFEJ.BizfejID
			FROM BIZFEJ
				 INNER JOIN BIZSOR ON BIZSOR.BizfejID = BIZFEJ.BizfejID
			WHERE BIZFEJ.MozgnemID=@beMozgnemID AND BIZFEJ.NapiAthely=1 AND BIZFEJ.Kelt=CAST(GETDATE() AS DATE) AND BIZSOR.RaktarID=@beRaktarID AND BIZSOR.CelRaktar=@kiRaktarID
		END

		IF @beBizfejID IS NULL
		BEGIN
			INSERT INTO BIZFEJ (Kelt,mozgnemID,DevizaID,Statusz,NapiAthely,CreUser) 
						VALUES (GETDATE(),@beMozgnemID,1,'Z',@napiAthely,@userID)

			SET @beBizfejID=SCOPE_IDENTITY()

			UPDATE BIZFEJ SET Eredeti = (SELECT Bizszam FROM BIZFEJ WHERE BizfejID = @kiBizfejID) WHERE BizfejID = @beBizfejID
		END

		INSERT INTO BIZSOR (BizfejID, CikkID, Mennyi, RaktarID, AfaID,
							Rtipus, RsorMeID, KedvezS, CreUser, CelRaktar) 
					VALUES (@kiBizfejID,@cikkID,@mennyi,@kiRaktarID,@afaID,
							'C',@meID,0,@userID,@beRaktarID)

		SET @bizsorID=SCOPE_IDENTITY()

		IF OBJECT_ID('tempdb..#temp_bizsorp') IS NOT NULL
			DROP TABLE #temp_bizsorp;

		CREATE TABLE #temp_bizsorp (hiba int, hibaszov varchar(MAX))

		--Trhely kezels
		IF @forrasRaktarPID IS NOT NULL
		BEGIN
			INSERT INTO #temp_bizsorp EXEC sp_bizsorp_insert @bizsorID, @forrasRaktarPID, NULL, @cikkID, @mennyi, NULL, @userID, @sorID
	
			SELECT @hiba=hiba, @hibaszov=hibaszov FROM #temp_bizsorp
			TRUNCATE TABLE #temp_bizsorp

			IF @hiba < 0
			BEGIN
				ROLLBACK TRAN
				SELECT @hiba AS hiba, @hibaszov AS hibaszov
				RETURN
			END
		END

		INSERT INTO BIZSOR (BizfejID, CikkID, Mennyi, EgysegAr, Ertek,
							RaktarID, AfaID, Rtipus, RsorMeID, KedvezS,
							CreUser, CelRaktar)
		SELECT @beBizfejID,@cikkID,@mennyi,EgysegAr,Ertek,
			   @beRaktarID, @afaID,'C',@meID,0,
			   @userID,@kiRaktarID
		FROM BIZSOR
		WHERE BizsorID=@bizsorID

		IF @celRaktarPID IS NOT NULL
		BEGIN
			SET @bizsorID=SCOPE_IDENTITY()

			INSERT INTO #temp_bizsorp EXEC sp_bizsorp_insert @bizsorID, NULL, @celRaktarPID, @cikkID, @mennyi, NULL, @userID, @sorID
	
			SELECT @hiba=hiba, @hibaszov=hibaszov FROM #temp_bizsorp
			DROP TABLE #temp_bizsorp

			IF @hiba < 0
			BEGIN
				ROLLBACK TRAN
				SELECT @hiba AS hiba, @hibaszov AS hibaszov
				RETURN
			END
		END

		COMMIT

		SELECT 0 AS hiba, '' AS hibaszov

	END TRY
	BEGIN CATCH
		ROLLBACK TRAN
		SELECT -1 AS hiba, Error_message() AS hibaszov
	END CATCH
END