CREATE PROCEDURE [dbo].[sp_login_rebuild]
AS 
BEGIN

BEGIN TRY
DECLARE @ujAdatbazis varchar(30), @command nvarchar(1000), @proxyAcc varchar(50), @serviceBroker bit, @felhasznalo varchar(50), @felhasznaloTipus char(1)

SET @ujAdatbazis = DB_NAME() + '_teszt_uj'

SELECT @proxyAcc = ProxyAcc FROM CEG

--Service Broker
SELECT @serviceBroker = is_broker_enabled FROM sys.databases WHERE name = DB_NAME()

IF @serviceBroker = 1
BEGIN
	SET @command = 'ALTER DATABASE ['+@ujAdatbazis+'] SET ENABLE_BROKER'
	PRINT @command
	EXEC (@command)
END

--Login
IF CURSOR_STATUS('global','LoginCursor')>=-1
BEGIN
	CLOSE LoginCursor
	DEALLOCATE LoginCursor
END

DECLARE LoginCursor CURSOR FOR

SELECT CASE WHEN authentication_type = 1  
	 THEN ('USE '+@ujAdatbazis+' IF NOT EXISTS (SELECT [name] FROM sys.database_principals WHERE [name] = ''' + [name] + '''' + ') BEGIN CREATE USER ' + QUOTENAME([name]) + ' FOR LOGIN ' + QUOTENAME(suser_sname([sid])) + ' WITH DEFAULT_SCHEMA = ' + QUOTENAME(ISNULL([default_schema_name], 'dbo')) + SPACE(1) + 'END; ')
	 ELSE ('USE '+@ujAdatbazis+' IF NOT EXISTS (SELECT [name] FROM sys.database_principals WHERE [name] = ''' + [name] + '''' + ') BEGIN CREATE USER ' + QUOTENAME([name]) + ' WITH DEFAULT_SCHEMA = ' + QUOTENAME(ISNULL([default_schema_name], 'dbo')) + SPACE(1) + 'END; ') END, name, type
FROM sys.database_principals
WHERE name <> 'dbo' AND authentication_type IN(1,3)

OPEN LoginCursor;

FETCH NEXT FROM LoginCursor INTO @command, @felhasznalo, @felhasznaloTipus
WHILE @@FETCH_STATUS = 0
BEGIN
	PRINT @command
	EXEC (@command)

	IF @proxyAcc IS NOT NULL AND @felhasznaloTipus = 'S'
	BEGIN
		SET @command = 'USE '+@ujAdatbazis+' GRANT IMPERSONATE ON USER:: ['+@proxyAcc+'] TO ['+@felhasznalo+']'
		PRINT @command
		EXEC (@command)
	END

	IF @serviceBroker = 1
	BEGIN
		SET @command = 'USE '+@ujAdatbazis+' GRANT CREATE SERVICE TO ['+@felhasznalo+']'
		PRINT @command
		EXEC (@command)

		SET @command = 'USE '+@ujAdatbazis+' GRANT CREATE QUEUE TO ['+@felhasznalo+']'
		PRINT @command
		EXEC (@command)

		SET @command = 'USE '+@ujAdatbazis+' GRANT SUBSCRIBE QUERY NOTIFICATIONS TO ['+@felhasznalo+']'
		PRINT @command
		EXEC (@command)

		SET @command = 'USE '+@ujAdatbazis+' GRANT CONTROL ON SCHEMA::[dbo] TO ['+@felhasznalo+']'
		PRINT @command
		EXEC (@command)

		SET @command = 'USE '+@ujAdatbazis+' GRANT IMPERSONATE ON USER::DBO TO ['+@felhasznalo+']'
		PRINT @command
		EXEC (@command)

		SET @command = 'USE '+@ujAdatbazis+' GRANT REFERENCES ON CONTRACT::[http://schemas.microsoft.com/SQL/Notifications/PostQueryNotification] TO ['+@felhasznalo+']'
		PRINT @command
		EXEC (@command)
	END

	FETCH NEXT FROM LoginCursor INTO @command, @felhasznalo, @felhasznaloTipus
END
CLOSE LoginCursor
DEALLOCATE LoginCursor

--Permission
DECLARE PermissionCursor CURSOR FOR

SELECT 'USE '+@ujAdatbazis+ ' ' + CASE 
	   WHEN perm.state <> 'W' 
			THEN perm.state_desc --W=Grant With Grant Option
	   ELSE 
			'GRANT'
	   END + 
	   SPACE(1) + perm.permission_name + --CONNECT, etc
	   SPACE(1) + 'TO' + SPACE(1) + '[' + USER_NAME(usr.principal_id) + ']' COLLATE database_default + --TO <user name>
	   CASE 
	   WHEN perm.state <> 'W'
			THEN SPACE(0) 
	   ELSE
			SPACE(1) + 'WITH GRANT OPTION'
	   END
FROM sys.database_permissions AS perm
	 INNER JOIN sys.database_principals AS usr ON perm.grantee_principal_id = usr.principal_id
WHERE [perm].[major_id] = 0 AND [usr].[principal_id] > 4 -- 0 to 4 are system users/schemas
AND name <> 'dbo' AND authentication_type IN(1,3)

OPEN PermissionCursor;

FETCH NEXT FROM PermissionCursor INTO @command
WHILE @@FETCH_STATUS = 0
BEGIN
	PRINT @command
	EXEC (@command)

	FETCH NEXT FROM PermissionCursor INTO @command
END
CLOSE PermissionCursor
DEALLOCATE PermissionCursor

--Rolemember
SET @command = 
	'USE '+@ujAdatbazis+'
	CREATE ROLE [KristalyDocLekerdez]
	GRANT SELECT ON dbo.TMP_DOC TO KristalyDocLekerdez'

EXEC (@command)

IF CURSOR_STATUS('global','RolememberCursor')>=-1
BEGIN
	CLOSE RolememberCursor
	DEALLOCATE RolememberCursor
END

DECLARE RolememberCursor CURSOR FOR

SELECT 'USE '+@ujAdatbazis+' EXEC sp_addrolemember @rolename ='+ SPACE(1) + QUOTENAME(USER_NAME(rm.role_principal_id), '''') + ', @membername =' + SPACE(1) + QUOTENAME(USER_NAME(rm.member_principal_id), '''')
FROM sys.database_role_members AS rm
WHERE USER_NAME(rm.member_principal_id) IN (
	SELECT [name]
	FROM sys.database_principals
	WHERE [principal_id] > 4 AND -- 0 to 4 are system users/schemas
		  name <> 'dbo' AND authentication_type IN(1,3))

OPEN RolememberCursor;

FETCH NEXT FROM RolememberCursor INTO @command
WHILE @@FETCH_STATUS = 0
BEGIN
	PRINT @command
	EXEC (@command)

	FETCH NEXT FROM RolememberCursor INTO @command
END
CLOSE RolememberCursor
DEALLOCATE RolememberCursor

/*SET @command = '
USE [master]
EXEC sp_configure ''show advanced options'', 1;
RECONFIGURE;
EXEC sp_configure ''xp_cmdshell'', 1;
RECONFIGURE;
EXEC sp_configure ''Ole Automation Procedures'', 1;
RECONFIGURE;'

PRINT @command
EXEC (@command)

IF @proxyAcc IS NOT NULL
BEGIN
	SET @command = 'USE [master] EXEC sp_xp_cmdshell_proxy_account '''+@proxyAcc+''', '''+@proxyAccJelszo+''
	PRINT @command
	EXEC (@command)

	SET @command = 'USE [master] EXEC sp_addsrvrolemember '''+@proxyAcc+''', ''bulkadmin'
	PRINT @command
	EXEC (@command)

	SET @command = 'USE [master] GRANT EXECUTE ON xp_cmdshell TO ['+@proxyAcc+']'
	PRINT @command
	EXEC (@command)

	SET @command = 'USE [master] GRANT EXECUTE ON sp_OACreate TO ['+@proxyAcc+']'
	PRINT @command
	EXEC (@command)

	SET @command = 'USE [master] GRANT EXECUTE ON sp_OAMethod TO ['+@proxyAcc+']'
	PRINT @command
	EXEC (@command)

	SET @command = 'USE [master] GRANT EXECUTE ON sp_OADestroy TO ['+@proxyAcc+']'
	PRINT @command
	EXEC (@command)
END*/

SET @command = 'USE ['+@ujAdatbazis+'] EXEC sp_changedbowner ''sa'''
PRINT @command
EXEC (@command)
		
SET @command = 'USE ['+@ujAdatbazis+'] ALTER DATABASE ['+@ujAdatbazis+'] SET TRUSTWORTHY ON'
PRINT @command
EXEC (@command)

PRINT 'Ksz'

END TRY
BEGIN CATCH
	IF CURSOR_STATUS('global','LoginCursor')>=-1
	BEGIN
		CLOSE LoginCursor
		DEALLOCATE LoginCursor
	END

	IF CURSOR_STATUS('global','RolememberCursor')>=-1
	BEGIN
		CLOSE RolememberCursor
		DEALLOCATE RolememberCursor
	END

	IF CURSOR_STATUS('global','PermissionCursor')>=-1
	BEGIN
		CLOSE PermissionCursor
		DEALLOCATE PermissionCursor
	END

	SELECT ERROR_MESSAGE() AS 'hiba'
END CATCH
END