create PROCEDURE [dbo].[sp_navxml_create] @sendXML varchar(max), @receiveXML varchar(max), @OnlineSzID int, @creUser smallint
AS
BEGIN
	DECLARE @docDirectory varchar(200), @path varchar(150), @mappankentFajlDb int = 1000, @ext varchar(5)

	--Szerver belső dokumentum könyvtára
	SELECT @docDirectory = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 244

	IF @docDirectory = ''
	BEGIN
		SELECT -1 AS hiba, 'Nincs megadva a "Szerver NAV XML könyvtára" rendszerparaméter' AS hibaszov
		RETURN
	END

	SELECT @ext ='XML'

	IF RIGHT(@docDirectory, 1) <> '\'
		SET @docDirectory = @docDirectory + '\'

	SET @path = @docDirectory + DB_NAME() + '\' + CAST((CEILING(CONVERT(decimal, @OnlineSzID) / @mappankentFajlDb) * @mappankentFajlDb) AS varchar) + '\' + CONVERT(varchar, @OnlineSzID) + 's.' + @ext
	Print @path
	IF OBJECT_ID('tempdb..#NavInsertResult') IS NOT NULL
		DROP TABLE #NavInsertResult;

	CREATE TABLE #NavInsertResult(hiba smallint, hibaszov varchar(200))

	INSERT #NavInsertResult (hiba, hibaszov)
	EXEC sp_fajl_create @sendXML, @path, @creUser
	
	--nincs hiba, akkor Fajlba bejegyzés
	IF((SELECT hiba FROM #NavInsertResult) = 0)
	BEGIN
		SET @path = @docDirectory + DB_NAME() + '\' + CAST((CEILING(CONVERT(decimal, @OnlineSzID) / @mappankentFajlDb) * @mappankentFajlDb) AS varchar) + '\' + CONVERT(varchar, @OnlineSzID) + 'r.' + @ext

		EXEC sp_fajl_create @receiveXML, @path, @creUser
		
		IF((SELECT hiba FROM #NavInsertResult) = 0)
		     UPDATE ONLINESZ SET Fajlba = GETDATE(),SendXml=null,ReceiveXML=null WHERE OnLineSzID = @OnlineSzID 
	END

	SELECT * FROM #NavInsertResult
END
