CREATE PROCEDURE [dbo].[sp_olvasfot_create] @dokumenTxt text, @olvasFotID int, @creUser smallint
AS
BEGIN
	DECLARE @docDirectory varchar(200), @path varchar(150), @mappankentFajlDb int = 1000

	--Szerver bels dokumentum knyvtra
	SELECT @docDirectory = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 190

	IF @docDirectory = ''
	BEGIN
		SELECT -1 AS hiba, 'Nincs megadva a "Szerver bels dokumentum knyvtra" rendszerparamter' AS hibaszov
		RETURN
	END

	IF RIGHT(@docDirectory, 1) <> '\'
		SET @docDirectory = @docDirectory + '\'

	SET @path = @docDirectory + DB_NAME() + '\LeolvasasFoto\' + CAST((CEILING(CONVERT(decimal, @olvasFotID) / @mappankentFajlDb) * @mappankentFajlDb) AS varchar) + '\' + CONVERT(varchar, @olvasFotID) + '.jpg'

	IF OBJECT_ID('tempdb..#FotInsertResult') IS NOT NULL
		DROP TABLE #FotInsertResult;

	CREATE TABLE #FotInsertResult(hiba smallint, hibaszov varchar(200))

	INSERT #FotInsertResult (hiba, hibaszov)
	EXEC sp_fajl_create @dokumenTxt, @path, @creUser

	SELECT * FROM #FotInsertResult
END