CREATE PROCEDURE [dbo].[sp_rebuild_index]
AS
BEGIN

	DECLARE @Table NVARCHAR(255), @cmd NVARCHAR(1000), @number int = 0

	SET @cmd = 'DECLARE TableCursor CURSOR STATIC FOR SELECT ''['' + table_catalog + ''].['' + table_schema + ''].['' + table_name + '']'' as tableName FROM [' + DB_NAME() + '].INFORMATION_SCHEMA.TABLES WHERE table_type = ''BASE TABLE'' ORDER BY tableName'

	-- create table cursor
	EXEC (@cmd)
	OPEN TableCursor

	FETCH NEXT FROM TableCursor INTO @Table
	WHILE @@FETCH_STATUS = 0
	BEGIN
		BEGIN TRY
			SET @number = @number + 1
			PRINT CAST(@number AS varchar) + '/' + CAST(@@CURSOR_ROWS AS varchar) + ' ' + @Table

			SET @cmd = 'ALTER INDEX ALL ON ' + @Table + ' REBUILD'
			EXEC (@cmd)
		END TRY
		BEGIN CATCH
			CLOSE TableCursor
			DEALLOCATE TableCursor
			SELECT -1 AS hiba, ERROR_MESSAGE() AS hibaszov
			RETURN
		END CATCH

		FETCH NEXT FROM TableCursor INTO @Table
	END

	CLOSE TableCursor
	DEALLOCATE TableCursor

	SELECT 0 AS hiba, 'OK' AS hibaszov
END