CREATE PROCEDURE [dbo].[sp_szamla_leker] @userID smallint, @stationID smallint, @datumtol date, @datumig date, @kimeno bit = 0
AS 
BEGIN
	SET NOCOUNT ON;
        SET DEADLOCK_PRIORITY LOW; 
	DECLARE @toolsPath varchar(200), @command varchar(8000), @object int, @returnValue int, @proxyAcc varchar(50)

	IF DB_NAME() LIKE '%teszt%'
		RETURN

	SET @proxyAcc = (SELECT TOP 1 LTRIM(RTRIM(ProxyAcc)) FROM CEG ORDER BY CegID)

	IF @proxyAcc = ''
		SET @proxyAcc = NULL

	--Ha van ToolsPath s bejelentkezsi adatok
	SELECT @toolsPath = LTRIM(RTRIM(ToolsPath)) FROM CEG WHERE OnSzlaTnev IS NOT NULL AND OnSzlaPass IS NOT NULL AND OnSzlaKey IS NOT NULL AND OnSzlaCky IS NOT NULL

	IF @toolsPath IS NULL
		RETURN

	IF RIGHT(@toolsPath,1) <> '\'
		SET @toolsPath = @toolsPath + '\'

	SELECT @command = @toolsPath+'OnlineSzamla\kri_nav.exe -operation:"queryInvoiceDigest" -test:0 -server:"'+@@SERVERNAME+'" -database:"'+DB_NAME()+'" -userID:'+CAST(@userID as varchar)+' -stationID:'+CAST(@stationID as varchar)+' -dateFrom:"'+CONVERT(varchar,@datumtol,23)+'" -dateTo:"'+CONVERT(varchar,@datumig,23)+'"'+(CASE WHEN @kimeno=1 THEN ' -outbound:1' ELSE '' END)

	IF @proxyAcc IS NOT NULL
	BEGIN
		EXECUTE AS USER = @proxyAcc
	END

	EXEC sp_oacreate 'WScript.Shell', @object OUT
	EXEC sp_oamethod @object, 'run', @returnValue OUT, @command, 0, 1 --1-es paramter, hogy vrja meg a mveletet
	EXEC sp_oadestroy @object

	IF @proxyAcc IS NOT NULL
	BEGIN
		REVERT
	END

	;WITH XMLNAMESPACES('http://schemas.nav.gov.hu/OSA/3.0/api' as ns2)
	SELECT 
		Tab.Col.value('(ns2:invoiceNumber)[1]', 'varchar(50)') AS 'Szszam',
		Tab.Col.value('(ns2:batchIndex)[1]', 'int') AS 'BatchIndex',
		Tab.Col.value('(ns2:invoiceOperation)[1]', 'varchar(6)') AS 'Muvelet',
		Tab.Col.value('(ns2:invoiceCategory)[1]', 'varchar(8)') AS 'Tipus',
		Tab.Col.value('(ns2:invoiceIssueDate)[1]', 'date') AS 'Szkelt',
		Tab.Col.value('(ns2:supplierTaxNumber)[1]', 'varchar(8)') AS 'SzAdoszam',
		Tab.Col.value('(ns2:supplierGroupMemberTaxNumber)[1]', 'varchar(8)') AS 'SzCsopAdoszam',
		Tab.Col.value('(ns2:supplierName)[1]', 'varchar(512)') AS 'Szneve',
		Tab.Col.value('(ns2:customerTaxNumber)[1]', 'varchar(8)') AS 'VAdoszam',
		Tab.Col.value('(ns2:customerGroupMemberTaxNumber)[1]', 'varchar(8)') AS 'VCsopAdoszam',
		Tab.Col.value('(ns2:customerName)[1]', 'varchar(512)') AS 'Vneve',
		Tab.Col.value('(ns2:paymentMethod)[1]', 'varchar(8)') AS 'Fizmod',
		Tab.Col.value('(ns2:paymentDate)[1]', 'date') AS 'Fizhat',
		Tab.Col.value('(ns2:invoiceAppearance)[1]', 'varchar(10)') AS 'Forma',
		Tab.Col.value('(ns2:source)[1]', 'varchar(3)') AS 'Forras',
		Tab.Col.value('(ns2:invoiceDeliveryDate)[1]', 'date') AS 'Tkelt',
		Tab.Col.value('(ns2:currency)[1]', 'varchar(3)') AS 'Deviza',
		Tab.Col.value('(ns2:invoiceNetAmount)[1]', 'money') AS 'Netto',
		Tab.Col.value('(ns2:invoiceNetAmountHUF)[1]', 'money') AS 'NettoFt',
		Tab.Col.value('(ns2:invoiceVatAmount)[1]', 'money') AS 'AFA',
		Tab.Col.value('(ns2:invoiceVatAmountHUF)[1]', 'money') AS 'AFAFt',
		Tab.Col.value('(ns2:transactionId)[1]', 'varchar(30)') AS 'TranzakcioID',
		Tab.Col.value('(ns2:index)[1]', 'tinyint') AS 'Index',
		Tab.Col.value('(ns2:originalInvoiceNumber)[1]', 'varchar(50)') AS 'SzlaHiv',
		Tab.Col.value('(ns2:modificationIndex)[1]', 'int') AS 'ModIndex',
		Tab.Col.value('(ns2:insDate)[1]', 'datetime') AS 'CreTime',
		CASE WHEN LOWER(Tab.Col.value('(ns2:completenessIndicator)[1]', 'varchar(5)')) = 'true' THEN 1 ELSE 0 END AS 'Eszamla'
	FROM TMPONLSZ
	CROSS APPLY ReceiveXML.nodes('/ns2:QueryInvoiceDigestResponse/ns2:invoiceDigestResult/ns2:invoiceDigest') as Tab(Col)
	WHERE TMPONLSZ.CreUser = @userID AND TMPONLSZ.StationID = @stationID

END