CREATE TRIGGER [dbo].[tr_bizfej_insert] ON [dbo].[BIZFEJ] 
FOR INSERT 
AS

DECLARE @mozgnemID int, @bizfejID int, @bizsor int, @bizjel char(5), @kelt date, @userID smallint, @telepID tinyint, @szallJel varchar(3), @szallSorsz int, @szallHossz tinyint, 
	    @evJel varchar(2), @szallLev bit, @cegkod varchar(5), @vevoid int, @varosid int, @varosirsz varchar(6), @msz varchar(6), @mszzsid int, @konyvev int, @bizhosz numeric(1,0)

SELECT @mozgnemID = mozgnemID, @bizfejID = BizfejID, @kelt = kelt, @userID = CreUser, @vevoid=vevoid FROM inserted

SELECT @bizjel = RTRIM(MOZGNEM.Bizjel), @bizsor = MOZGNEM.Bizsor, @szallLev = MOZGNEM.SzallLev, @konyvev = MOZGNEM.KonyvEv, @evJel = RIGHT(RTRIM(EVEK.Ev),2), @bizhosz = ISNULL(MOZGNEM.Bizhosz,4)
FROM MOZGNEM
	 INNER JOIN EVEK ON EVEK.EvekID = MOZGNEM.KonyvEv
WHERE MOZGNEM.MozgnemID = @mozgnemID

BEGIN TRY
	IF @szallLev <> 1
	BEGIN
		
		UPDATE MOZGNEM SET Bizsor = Bizsor + 1 WHERE MozgnemID = @mozgnemID
		UPDATE BIZFEJ SET Bizszam = RTRIM(@bizjel) + '-' + RIGHT('00000000' + LTRIM(STR(@bizsor + 1)), @bizhosz) + '-' + @evJel WHERE BizfejID = @bizfejID

	END
	ELSE
	BEGIN
		SELECT @bizfejID = BizfejID, @userID = CreUser, @telepID = TelepID FROM inserted

		IF @telepID IS NULL OR @telepID = 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN
		END

		SELECT @szallJel = SzallJel, @szallSorsz = ISNULL(SzallSorsz, 0), @szallHossz = SzallHossz, @evJel = EvJel FROM TELEP WHERE TelepID = @telepID

		UPDATE BIZFEJ SET Bizszam = LTRIM(RTRIM(@szallJel)) + '-' + @evJel + '-' + REPLACE(STR(@szallSorsz + 1, @szallHossz), SPACE(1), '0') WHERE BizfejID = @bizfejID
		UPDATE TELEP SET SzallSorsz = @szallSorsz + 1 WHERE TelepID = @telepID
		select @cegkod=cegkod from ceg
		if left(@cegkod,3)='DDH' and @vevoid>0
		  BEGIN
			 select @varosid=szgvarosID from szghely where vevoid=@vevoid
			 if @varosid is null
			    select @varosid=varosid from vevo where vevoid=@vevoid
        		 if @varosid>0
			     BEGIN
				 select @varosirsz=varosirsz from varosok where varosid=@varosid
				 if @varosirsz  is not null and @varosirsz>='7400' and @varosirsz<='7409'
				   set @msz='711-09'
				 else
				   set @msz='71209'
				 select @mszzsid=sztukorid from sztukor where szsz=@msz and  konyvev=@konyvev
				 UPDATE BIZFEJ SET mszszid=@mszzsid WHERE BizfejID = @bizfejID 
				 END
 	
		  END
		if left(@cegkod,3)='KHG' and @vevoid>0
		  BEGIN
			 select @varosid=szgvarosID from szghely where vevoid=@vevoid
			 if @varosid is null
			    select @varosid=varosid from vevo where vevoid=@vevoid
        		 if @varosid>0
			     BEGIN
				 select @varosirsz=varosirsz from varosok where varosid=@varosid
				 if @varosirsz  is not null and @varosirsz>='7400' and @varosirsz<='7409'
				   set @msz='71107'
				 else
				   set @msz='71207'
				 select @mszzsid=sztukorid from sztukor where szsz=@msz and  konyvev=@konyvev
				 UPDATE BIZFEJ SET mszszid=@mszzsid WHERE BizfejID = @bizfejID 
				 END
 	
		  END


	END

END TRY
BEGIN CATCH
	ROLLBACK TRANSACTION
END CATCH