CREATE TRIGGER [dbo].[tr_bizsor_insert] ON [dbo].[BIZSOR]
FOR INSERT, UPDATE
AS

DECLARE @keszletSql nvarchar(1000) = '',

--INSERT
@insert bit = 1,

--BIZSOR
@bizsorID int, @bizfejID int, @cikkID int, @raktarID int, @mennyi decimal(10,3),
@egysegAr money, @elsz_ert money, @raktarTip char(1), @celRaktarTip char(1), @uzemekID int,
@dBizsorID int, @sztukorid2 int, @van bit, @szolgID smallint, @cikkSarzID int, @dCikkSarzID int,

--BIZFEJ
@szallitoID int, @bizKelt date, @bizszam varchar(12), @tetelfejID int, @devizaID tinyint,
@kedvezmeny numeric(5,2), @ktghelyID smallint, @munkszamID smallint, @mszszID int, @munkalapID int,
@creUser smallint, @netto money, @afa money, @nettoFt money, @afaFt money,
@nettoDeviza money, @afaDeviza money, @db int, @vanZaro int,@eszkozid int,@vevoid int,

--MOZGNEM
@konyvEv tinyint, @irany char(1), @szSzam varchar(8), @bizszov varchar(30), @specKod char(1),
@partner char(1), @bizjel varchar(4),

--DEVIZA
@szlaRound tinyint,

--KESZLET
@keszletID int, @halmBevet decimal(11,3), @halmKiadas decimal(11,3), @keszletMennyi decimal(11,3), @raktErtek money, @uKivKelt date, @atlagAr money,

--KESZLETS
@keszletSID int,

--Kltsg feloszts
@ktgfelID int,

--FIFO
@fifoar money,

-- TETELFEJ
@konyvelve char(1),@rgzneve varchar(11),

--Szmlzs
@sztetelID int, @dSztetelID int

SELECT @bizsorID=inserted.BizsorID, @bizfejID=inserted.BizfejID, @cikkID=inserted.CikkID, @raktarID=inserted.RaktarID, @mennyi=inserted.Mennyi,
       @egysegAr=inserted.EgysegAr, @elsz_ert=inserted.Ertek, @raktarTip=RAKTAR.RaktarTip, @celRaktarTip=ISNULL(CELRAKTAR.RaktarTip,' '),
       @uzemekID=(CASE WHEN inserted.Uzemekid IS NULL THEN RAKTAR.UzemekID ELSE inserted.Uzemekid END),
	   @szallitoID=BIZFEJ.SzallitoID, @vevoid=bizfej.vevoid,@bizKelt=BIZFEJ.Kelt, @bizszam=BIZFEJ.Bizszam, @tetelfejID=BIZFEJ.tetelfejID, @devizaID=BIZFEJ.DevizaID,
	   @kedvezmeny=BIZFEJ.Kedvezmeny, @ktghelyID=BIZFEJ.ktghelyID, @munkszamID=BIZFEJ.munkszamID, @mszszID=BIZFEJ.mszszID, @munkalapID=BIZFEJ.MunkalapID,
	   @creUser=BIZFEJ.CreUser, @konyvEv=MOZGNEM.KonyvEv, @irany=MOZGNEM.Irany, @szSzam=MOZGNEM.SzSzam, @bizszov=MOZGNEM.MnemNeve,
	   @specKod=MOZGNEM.SpecKod, @partner=MOZGNEM.Partner, @bizjel=MOZGNEM.Bizjel, @szlaRound=DEVIZA.SzlaRound, @sztetelID=SztetelID,
	   @eszkozid=bizfej.eszkozid,@szolgID=inserted.SzolgID,@cikkSarzID=CikkSarzID
FROM inserted
     LEFT JOIN RAKTAR ON inserted.RaktarID=RAKTAR.RaktarID
     LEFT JOIN RAKTAR CELRAKTAR ON CELRAKTAR.RaktarID=inserted.CelRaktar
	 INNER JOIN BIZFEJ ON BIZFEJ.BizfejID=inserted.BizfejID
	 LEFT JOIN MOZGNEM ON BIZFEJ.mozgnemID=MOZGNEM.MozgnemID
     LEFT JOIN DEVIZA ON DEVIZA.DevizaID=BIZFEJ.DevizaID

SELECT @dBizsorID=BizsorID, @dSztetelID=SztetelID, @dCikkSarzID=CikkSarzID FROM deleted

--UPDATE
IF @dBizsorID IS NOT NULL
BEGIN
	SET @insert=0

	--Szlltlevl szmlzs
	IF @dSztetelID IS NULL AND @sztetelID IS NOT NULL
		RETURN
END

--Kszlet kezels
IF ISNULL(@cikkID,0) > 0
BEGIN
	SELECT @keszletID=keszletID, @keszletMennyi=Mennyi, @uKivKelt=Ukivkelt, @atlagAr=ISNULL(AtlagAr,0) FROM KESZLET WHERE CikkID=@cikkID AND RaktarID=@raktarID

	--Nincs mg ilyen kszlet
	IF @@ROWCOUNT=0 
    BEGIN
		INSERT INTO KESZLET (CikkID, RaktarID) VALUES (@cikkID, @raktarID)
		SET @keszletID=SCOPE_IDENTITY()
		SET @atlagAr=0
	END

	--Van-e ves zrs
	SELECT @vanZaro=BIZFEJ.BizfejID
	FROM BIZFEJ
		 INNER JOIN  MOZGNEM ON BIZFEJ.mozgnemID=MOZGNEM.MozgnemID
	WHERE MOZGNEM.Bizjel='ZARO' AND BIZFEJ.Tetelszam > 0

	--FIFO
	IF dbo.fc_setup('R',@konyvEv,60)='FIFO'
	BEGIN
		IF @irany = 'C'
		BEGIN
			--Storn
			IF @mennyi < 0
			BEGIN
				--Stornzskor eredeti bizonylatsor keress s trls
				DECLARE @stornozottBizsorID int

				SELECT @stornozottBizsorID=EREDETIBIZSOR.BizsorID 
				FROM BIZFEJ
					 INNER JOIN BIZSOR ON BIZSOR.BizfejID=BIZFEJ.BizfejID
					 INNER JOIN BIZFEJ EREDETIBIZFEJ ON EREDETIBIZFEJ.Bizszam=BIZFEJ.Eredeti
					 INNER JOIN BIZSOR EREDETIBIZSOR ON EREDETIBIZSOR.BizfejID=EREDETIBIZFEJ.BizfejID AND EREDETIBIZSOR.CikkID=BIZSOR.CikkID AND EREDETIBIZSOR.RaktarID=BIZSOR.RaktarID AND EREDETIBIZSOR.Mennyi=(BIZSOR.Mennyi * -1)
				WHERE BIZSOR.BizsorID=@bizsorID AND 
					  EXISTS (SELECT BIZFIFO.BizfifoID FROM BIZFIFO WHERE BIZFIFO.KibizsorID=EREDETIBIZSOR.BizsorID)

				IF @stornozottBizsorID IS NOT NULL
					exec dbo.sp_fifo 2, @cikkID, @raktarID, @bizKelt, @mennyi, @stornozottBizsorID
			END
			ELSE
			BEGIN
				CREATE TABLE #fifo (ar money)

				IF @insert=1
					INSERT INTO #fifo(ar) EXEC dbo.sp_fifo 1, @cikkID, @raktarID, @bizKelt, @mennyi, @bizsorID
				ELSE
					INSERT INTO #fifo(ar) EXEC dbo.sp_fifo 4, @cikkID, @raktarID, @bizKelt, @mennyi, @bizsorID

				SELECT @fifoar=ar FROM #fifo

				UPDATE BIZSOR SET EgysegAr=@fifoar, Ertek=@fifoar * Mennyi WHERE BizsorID=@bizsorID

				SET @egysegAr=@fifoar
				SET @elsz_ert=(SELECT Ertek FROM BIZSOR WHERE BizsorID=@bizsorID)
			END
		END
	END
	--Nem FIFO kszlet cskkens (cskken pozitv mennyisg, vagy nvekv negatv mennyisg s nem szllti bevt)
	ELSE IF (@irany='C' AND @mennyi >= 0) OR (@irany = 'N' AND @mennyi < 0 AND @partner <> 'S')
	BEGIN
		--INSERT
		IF @insert=1
		BEGIN
			SET @egysegAr=@atlagAr
			SET @elsz_ert=@atlagAr * @mennyi

			--Egysgr s rtk az tlagrhoz, beszerzsi r az utols beszerzsi r
			UPDATE BIZSOR SET EgysegAr=@egysegAr, Ertek=@elsz_ert, BeszAr=(SELECT ISNULL(BeszAr,0) FROM CIKK WHERE CikkID=@cikkID) WHERE BizsorID=@bizsorID
		END
		--UPDATE
		ELSE
		BEGIN
				
			--Korbbi dtum bizonylatsorok vagy ugyanazon a napon kszlt kisebb sorszm bizonylatsorok s adott vi vagy minden bizonylatsor
			SELECT @raktErtek=ISNULL(SUM((CASE WHEN MOZGNEM.Irany = 'N' THEN 1 ELSE -1 END) * BIZSOR.Ertek),0),
				   @keszletMennyi=ISNULL(SUM((CASE WHEN MOZGNEM.Irany = 'N' THEN 1 ELSE -1 END) * BIZSOR.Mennyi),0)
			FROM BIZSOR
				 INNER JOIN BIZFEJ ON BIZFEJ.BizfejID=BIZSOR.BizfejID
				 INNER JOIN MOZGNEM ON MOZGNEM.MozgnemID=BIZFEJ.mozgnemID
			WHERE BIZSOR.RaktarID=@raktarID AND BIZSOR.CikkID=@cikkID AND 
				  ((BIZSOR.BizsorID<@bizsorID AND BIZFEJ.Kelt=@bizKelt) OR BIZFEJ.Kelt<@bizkelt) AND (YEAR(BIZFEJ.Kelt)=YEAR(@bizKelt) OR ISNULL(@vanZaro,0)=0)
				
			--Ha negatv a kszlet, vagy tbbet vagy pontosan annyit akar kiadni, mint a kszleten lv, akkor maximum az aktulis kszletrtk lehet
			IF @mennyi = @keszletMennyi
			BEGIN
				SET @elsz_ert=@raktErtek
				SET @egysegAr=@raktErtek / @mennyi
			END
			ELSE
			BEGIN
				SET @egysegAr=@raktErtek / (CASE WHEN @keszletMennyi = 0 THEN 1 ELSE @keszletMennyi END)
				SET @elsz_ert=@egysegAr * @mennyi
			END

			--Egysgr s rtk az tlagrhoz
			UPDATE BIZSOR SET EgysegAr=@egysegAr, Ertek=@elsz_ert WHERE BizsorID=@bizsorID
		END
	END

	--Kszlet jraszmols
	SELECT @halmBevet=ISNULL(SUM(CASE WHEN MOZGNEM.Irany = 'N' THEN BIZSOR.Mennyi ELSE 0 END),0),
		   @halmKiadas=ISNULL(SUM(CASE WHEN MOZGNEM.Irany = 'C' THEN BIZSOR.Mennyi ELSE 0 END),0),
		   @raktErtek=ISNULL(SUM((CASE WHEN MOZGNEM.Irany = 'N' THEN 1 ELSE -1 END) * BIZSOR.Ertek),0)
	FROM BIZSOR
		 INNER JOIN BIZFEJ ON BIZFEJ.BizfejID=BIZSOR.BizfejID
		 INNER JOIN MOZGNEM ON MOZGNEM.MozgnemID=BIZFEJ.mozgnemID
	WHERE BIZSOR.RaktarID=@raktarID AND BIZSOR.CikkID=@cikkID and (YEAR(BIZFEJ.Kelt)=YEAR(@bizKelt) OR ISNULL(@vanZaro,0)=0)
	
	SET @keszletMennyi=@halmBevet-@halmKiadas

	SET @keszletSql = @keszletSql + 'Mennyi=' + CONVERT(varchar, @keszletMennyi) + ', HalmBevet=' + CONVERT(varchar, @halmBevet) + ', HalmKiadas=' + CONVERT(varchar, @halmKiadas)

	--0 kszlet
	IF @keszletMennyi=0
	BEGIN
		--bizonylatsorok kerektsei miatti eltrs
		/*IF @raktErtek <> 0
		BEGIN
			DECLARE @bizsorErtek money
			DECLARE @bizsorMennyi dec (8,2) --mdostshoz
			SELECT @bizsorErtek=Ertek, @bizsorMennyi=Mennyi FROM BIZSOR WHERE BizsorID=@bizsorID		
			SET @bizsorErtek=@bizsorErtek + @raktErtek
			SET @egysegAr=@bizsorErtek / @bizsorMennyi

			UPDATE BIZSOR SET Ertek=@bizsorErtek, EgysegAr=@egysegAr WHERE BizsorID=@bizsorID
		END*/
		
		SET @keszletSql = @keszletSql + ', RaktErtek=0' 
	END
	--Nem 0 kszlet
	ELSE
	BEGIN

		SET @keszletSql = @keszletSql + ', RaktErtek=' + CONVERT(varchar, @raktErtek)

		--tlagr tszmols csak pozitv kszlet esetn
		IF @keszletMennyi > 0
			SET @keszletSql = @keszletSql + ', AtlagAr=ISNULL(' + CONVERT(varchar, @raktErtek) + ',0) / ' + CONVERT(varchar, @keszletMennyi)
	END

	--Utols kivt kezels, j s nem zr bizonylat
	IF ((@irany='C' AND @mennyi > 0) OR (@irany='N' AND @mennyi < 0)) AND @bizjel <> 'ZARO'
	BEGIN
		--j rgzts
		IF @dBizsorID IS NULL
		BEGIN
			IF @bizKelt > ISNULL(@uKivKelt,CONVERT(smalldatetime,'1900.01.01'))
				SET @keszletSql = @keszletSql + ', Ukivkelt=''' + CONVERT(varchar, @bizKelt, 23) + ''''
		END
		--Mdosts
		ELSE
		BEGIN
			SELECT @uKivKelt = MAX(BIZFEJ.Kelt)
			FROM BIZSOR
					INNER JOIN BIZFEJ ON BIZFEJ.BizfejID = BIZSOR.BizfejID
					INNER JOIN MOZGNEM ON MOZGNEM.MozgnemID = BIZFEJ.mozgnemID
			WHERE BIZSOR.CikkID = @cikkID AND BIZSOR.RaktarID = @raktarID AND MOZGNEM.Bizjel <> 'ZARO' AND
			((MOZGNEM.Irany = 'C' AND BIZSOR.Mennyi > 0) OR (MOZGNEM.Irany = 'N' AND BIZSOR.Mennyi < 0))

			SET @keszletSql = @keszletSql + ', Ukivkelt=''' + CONVERT(varchar, @uKivKelt, 23) + ''''
		END
	END
	--Utols bevtelezs dtuma
	ELSE IF @partner = 'S' AND ((@irany='N' AND @mennyi > 0) OR (@irany='C' AND @mennyi < 0))
	BEGIN
		--j rgzts
		IF @dBizsorID IS NULL
		BEGIN
			IF @bizKelt > (SELECT ISNULL(BeszDatum,CONVERT(smalldatetime,'1900.01.01')) FROM CIKK WHERE CikkID=@cikkID)
				UPDATE CIKK SET BeszDatum=@bizKelt WHERE CikkID=@cikkID
		END
	END

	--LOT kezels
	IF @cikkSarzID IS NOT NULL
	BEGIN
		SELECT @keszletSID=KeszletSID FROM KESZLETS WHERE KeszletID=@keszletID AND CikkSarzID=@cikkSarzID

		--Nincs mg ilyen kszlet
		IF @@ROWCOUNT=0 
		BEGIN
			INSERT INTO KESZLETS (KeszletID, CikkSarzID, SMennyi) VALUES (@keszletID, @cikkSarzID, @mennyi)
			SET @keszletSID=SCOPE_IDENTITY()
		END
		ELSE
		BEGIN
			--Kszlet jraszmols
			SELECT @halmBevet=ISNULL(SUM(CASE WHEN MOZGNEM.Irany = 'N' THEN BIZSOR.Mennyi ELSE 0 END),0),
				   @halmKiadas=ISNULL(SUM(CASE WHEN MOZGNEM.Irany = 'C' THEN BIZSOR.Mennyi ELSE 0 END),0)
			FROM BIZSOR
				 INNER JOIN BIZFEJ ON BIZFEJ.BizfejID=BIZSOR.BizfejID
				 INNER JOIN MOZGNEM ON MOZGNEM.MozgnemID=BIZFEJ.mozgnemID
			WHERE BIZSOR.RaktarID=@raktarID AND BIZSOR.CikkID=@cikkID and (YEAR(BIZFEJ.Kelt)=YEAR(@bizKelt) OR ISNULL(@vanZaro,0)=0) AND BIZSOR.CikkSarzID=@cikkSarzID

			UPDATE KESZLETS SET SMennyi=@halmBevet-@halmKiadas WHERE KeszletSID=@keszletSID
		END

		--LOT mdosts
		IF @dBizsorID IS NOT NULL AND @cikkSarzID <> @dCikkSarzID
		BEGIN
			--Kszlet jraszmols
			SELECT @halmBevet=ISNULL(SUM(CASE WHEN MOZGNEM.Irany = 'N' THEN BIZSOR.Mennyi ELSE 0 END),0),
				   @halmKiadas=ISNULL(SUM(CASE WHEN MOZGNEM.Irany = 'C' THEN BIZSOR.Mennyi ELSE 0 END),0)
			FROM BIZSOR
				 INNER JOIN BIZFEJ ON BIZFEJ.BizfejID=BIZSOR.BizfejID
				 INNER JOIN MOZGNEM ON MOZGNEM.MozgnemID=BIZFEJ.mozgnemID
			WHERE BIZSOR.RaktarID=@raktarID AND BIZSOR.CikkID=@cikkID and (YEAR(BIZFEJ.Kelt)=YEAR(@bizKelt) OR ISNULL(@vanZaro,0)=0) AND BIZSOR.CikkSarzID=@dCikkSarzID

			UPDATE KESZLETS SET SMennyi=@halmBevet-@halmKiadas WHERE KeszletSID=@keszletSID
		END
	END

END
ELSE --Szolgltats nkltsgi r
IF ISNULL(@szolgID,0) > 0 AND ((@irany='C' AND @mennyi >= 0) OR (@irany = 'N' AND @mennyi < 0 AND @partner <> 'S'))
BEGIN
	UPDATE BIZSOR SET BeszAr=(SELECT ISNULL(OnkoltAr,0) FROM SZOLGAL WHERE SzolgID=@szolgID) WHERE BizsorID=@bizsorID
END

IF @keszletSql <> ''
BEGIN
	SET @keszletSql = 'UPDATE KESZLET SET ' + @keszletSql + ' WHERE KeszletID=' + CONVERT(varchar, @keszletID)
	exec sp_executesql @keszletSql
END

--Bizonylat fej ttelszm, nett, brutt, szlltlevl nett, szlltlevl brutt, devizartk jraszmols
SELECT @netto=SUM(BIZSOR.Ertek), 
       @afa=SUM(BIZSOR.Ertek * (AFAK.Szaz/100)),
       @nettoFt=SUM(ISNULL(BIZSOR.EladAr,0) * BIZSOR.Mennyi), 
       @afaFt=SUM(ISNULL(BIZSOR.EladAr,0) * BIZSOR.Mennyi * (AFAK.Szaz/100)), 
       @nettoDeviza=SUM(ISNULL(BIZSOR.DevizaAr,0) * BIZSOR.Mennyi), 
       @afaDeviza=SUM(ISNULL(BIZSOR.DevizaAr,0) * BIZSOR.Mennyi * (AFAK.Szaz/100)),
       @db=COUNT(BIZSOR.BizsorID) 
FROM BIZSOR 
     LEFT JOIN AFAK ON BIZSOR.AfaID=AFAK.AfaID
WHERE BIZSOR.BizfejID=@bizfejID

SET @kedvezmeny=ISNULL(@kedvezmeny,0)
SET @netto=ISNULL(@netto,0)
SET @afa=ISNULL(@afa,0)
SET @db=ISNULL(@db,0)

SET @netto=ROUND(@netto, 0)
SET @afa=ROUND(@afa, 0)

--Elads Ft-os rtk
SET @nettoFt=ROUND(@nettoFt * (100-@kedvezmeny)/100, 0)
SET @afaFt=ROUND(@afaFt * (100-@kedvezmeny)/100, 0)

--Elads devizs rtk
IF @devizaID IS NOT NULL AND @devizaID <> 1
BEGIN
	SET @nettoDeviza=ROUND(@nettoDeviza * (100-@kedvezmeny)/100, @szlaRound)
	SET @afaDeviza=ROUND(@afaDeviza * (100-@kedvezmeny)/100, @szlaRound)
END
ELSE
BEGIN
	SET @nettoDeviza=NULL
	SET @afaDeviza=NULL
END

UPDATE BIZFEJ SET Tetelszam=@db, Netto=@netto, Brutto=@netto+@afa, NettoS=@nettoFt, BruttoS=@nettoFt+@afaFt, DevizaErt=@nettoDeviza+@afaDeviza WHERE BizfejID=@bizfejID

--Szllti rendelsben keress
Declare  @maradek decimal(10,3)
IF @irany='N' AND @szallitoID>0
BEGIN
	DECLARE @rendssorID int, @rendssorMennyi decimal(10,3)

	IF CURSOR_STATUS('global','rendssorcursor')>=-1
	DEALLOCATE rendssorcursor

	--INSERT
	IF @insert=1
	BEGIN
		DECLARE rendssorcursor CURSOR FOR
		SELECT RENDSSOR.RendssorID, RENDSSOR.Mennyi
		FROM RENDSSOR
			 INNER JOIN RENDSFEJ ON RENDSFEJ.RendsfejID = RENDSSOR.RendsfejID
		WHERE RENDSSOR.BizsorID IS NULL AND RENDSFEJ.SzallitoID=@szallitoID AND RENDSSOR.RaktID=@raktarID AND RENDSSOR.CikkID=@cikkID
		ORDER BY RENDSFEJ.Kelt, RENDSSOR.Mennyi, RENDSSOR.RendssorID

		SET @maradek=@mennyi

		OPEN rendssorcursor
		FETCH rendssorcursor INTO @rendssorID,@rendssorMennyi
		WHILE @@Fetch_status=0 AND @maradek>0
		BEGIN
			--kevesebb vagy egyenl a rendelt mennyisg, mint a bevtelezett mennyisg
			IF @rendssorMennyi<=@maradek
			BEGIN
				UPDATE RENDSSOR SET BizsorID=@bizsorID WHERE RendssorID=@rendssorID

				SET @maradek=@maradek-@rendssorMennyi
			END
			--tbb a rendelt mennyisg, mint a bevtelezs -> soroszts
			ELSE
			BEGIN
				UPDATE RENDSSOR SET BizsorID=@bizsorID, Mennyi=@maradek WHERE RendssorID=@rendssorID

				INSERT INTO RENDSSOR (RendsfejID, CikkID, szolgID, Mennyi, Egysegar, Ehatarido, Rtipus, Megjegyz, Afaid, kedvezs, RsorMeid, RaktID) 
									 (SELECT RendsfejID, CikkID, szolgID, @rendssorMennyi - @maradek, Egysegar, Ehatarido, Rtipus, Megjegyz, Afaid, kedvezs, RsorMeid, RaktID FROM RENDSSOR WHERE RendssorID = @rendssorID)

				BREAK
			END

			FETCH rendssorcursor INTO @rendssorID,@rendssorMennyi
		END
		CLOSE rendssorcursor
		DEALLOCATE rendssorcursor
	END
	--UPDATE
	ELSE
	BEGIN
		DECLARE rendssorcursor CURSOR FOR
		SELECT RENDSSOR.RendssorID, RENDSSOR.Mennyi
		FROM RENDSSOR
			 INNER JOIN RENDSFEJ ON RENDSFEJ.RendsfejID = RENDSSOR.RendsfejID
		WHERE (RENDSSOR.BizsorID IS NULL OR RENDSSOR.BizsorID=@bizsorID) AND RENDSFEJ.SzallitoID=@szallitoID AND RENDSSOR.RaktID=@raktarID AND RENDSSOR.CikkID=@cikkID
		ORDER BY ISNULL(RENDSSOR.BizsorID,2147483647), RENDSFEJ.Kelt, RENDSSOR.Mennyi, RENDSSOR.RendssorID

		SET @maradek=@mennyi

		OPEN rendssorcursor
		FETCH rendssorcursor INTO @rendssorID,@rendssorMennyi
		WHILE @@Fetch_status=0
		BEGIN
			--ha nincs mr bevtelezett mennyisg
			IF @maradek=0
			BEGIN
				UPDATE RENDSSOR SET BizsorID=NULL WHERE RendssorID=@rendssorID
			END
			--kevesebb vagy egyenl a rendelt mennyisg, mint a bevtelezett mennyisg
			ELSE IF @rendssorMennyi<=@maradek
			BEGIN
				UPDATE RENDSSOR SET BizsorID=@bizsorID WHERE RendssorID=@rendssorID
				SET @maradek=@maradek-@rendssorMennyi
			END
			--tbb a rendelt mennyisg, mint a bevtelezs -> soroszts
			ELSE
			BEGIN
				UPDATE RENDSSOR SET BizsorID=@bizsorID, Mennyi=@maradek WHERE RendssorID=@rendssorID

				INSERT INTO RENDSSOR (RendsfejID, CikkID, szolgID, Mennyi, Egysegar, Ehatarido, Rtipus, Megjegyz, Afaid, kedvezs, RsorMeid, RaktID) 
									 (SELECT RendsfejID, CikkID, szolgID, @rendssorMennyi - @maradek, Egysegar, Ehatarido, Rtipus, Megjegyz, Afaid, kedvezs, RsorMeid, RaktID FROM RENDSSOR WHERE RendssorID = @rendssorID)

				SET @maradek=0
			END

			FETCH rendssorcursor INTO @rendssorID,@rendssorMennyi
		END
		CLOSE rendssorcursor
		DEALLOCATE rendssorcursor
	END
END

IF ISNULL(@cikkID,0)=0
	RETURN

--TODO, csak ha ez az utols ttel
--Szllt utols ra
IF @irany='N' AND @egysegAr<>0 AND @szallitoID>0
	UPDATE CIKKCEGS SET LastAr=@egysegAr, LastIn=@bizKelt WHERE CikkID=@cikkID AND SzallitoID=@szallitoID AND (LastIn<=@bizKelt OR LastIn IS NULL)

--Munkalap anyagkltsg
IF @munkalapID IS NOT NULL
begin
	
		DECLARE @rendvsorID int, @rendvsorMennyi decimal(10,3)
	UPDATE MUNKLAP SET KtgAnyag=(
		SELECT ISNULL(SUM((CASE WHEN MOZGNEM.Irany = 'C' THEN 1 ELSE -1 END) * BIZSOR.Ertek),0)  AS 'Ertek'
		FROM BIZSOR
			 INNER JOIN BIZFEJ ON BIZFEJ.BizfejID = BIZSOR.BizfejID
			 INNER JOIN MOZGNEM ON MOZGNEM.MozgnemID = BIZFEJ.mozgnemID
		WHERE BIZFEJ.MunkalapID=@munkalapID AND BIZSOR.CikkID IS NOT NULL)
	WHERE MunkalapID=@munkalapID
	select @vevoid=vevoid from munklap where munkalapid=@munkalapid
IF CURSOR_STATUS('global','rendvsorcursor')>=-1
	DEALLOCATE rendvsorcursor

	--INSERT
	IF @insert=1
	BEGIN
		DECLARE rendvsorcursor CURSOR FOR
		SELECT RENDvSOR.RendvsorID, RENDvSOR.Mennyi
		FROM RENDvSOR
			 INNER JOIN RENDvFEJ ON RENDvFEJ.RendvfejID = RENDvSOR.RendvfejID
		WHERE RENDvSOR.BizSorID IS NULL AND RENDvFEJ.vevoid=@vevoid AND RENDvSOR.RaktID=@raktarID AND RENDvSOR.CikkID=@cikkID
		ORDER BY RENDvFEJ.Kelt, RENDvSOR.Mennyi, RENDvSOR.RendvsorID

		SET @maradek=@mennyi

		OPEN rendvsorcursor
		FETCH rendvsorcursor INTO @rendvsorID,@rendvsorMennyi
		WHILE @@Fetch_status=0 AND @maradek>0
		BEGIN
			--kevesebb vagy egyenl a rendelt mennyisg, mint a bevtelezett mennyisg
			IF @rendvsorMennyi<=@maradek
			BEGIN
				UPDATE RENDvSOR SET BizSorID=@bizsorID WHERE RendvsorID=@rendvsorID

				SET @maradek=@maradek-@rendvsorMennyi
			END
			--tbb a rendelt mennyisg, mint a bevtelezs -> soroszts
			ELSE
			BEGIN
				UPDATE RENDvSOR SET BizSorID=@bizsorID, Mennyi=@maradek WHERE RendvsorID=@rendvsorID

				INSERT INTO RENDvSOR (RendvfejID, CikkID, szolgID, Mennyi, Egysegar, Ehatarido, Rtipus, Megjegyz, Afaid, kedvezs, RsorMeid, RaktID,MunkalapID) 
									 (SELECT RendvfejID, CikkID, szolgID, @rendvsorMennyi - @maradek, Egysegar, Ehatarido, Rtipus, Megjegyz, Afaid, kedvezs, RsorMeid, RaktID,MunkalapID FROM RENDvSOR WHERE RendvsorID = @rendvsorID)

				BREAK
			END

			FETCH rendvsorcursor INTO @rendvsorID,@rendvsorMennyi
		END
		CLOSE rendvsorcursor
		DEALLOCATE rendvsorcursor
	END
	--UPDATE
	ELSE
	BEGIN
      DECLARE rendvsorcursor CURSOR FOR
		SELECT RENDvSOR.RendvsorID, RENDvSOR.Mennyi
		FROM RENDvSOR
			 INNER JOIN RENDvFEJ ON RENDvFEJ.RendvfejID = RENDvSOR.RendvfejID
		WHERE (RENDvSOR.BizSorID IS NULL OR RENDvSOR.BizSorID=@bizsorID) AND RENDvFEJ.vevoid=@vevoid AND RENDvSOR.RaktID=@raktarID AND RENDvSOR.CikkID=@cikkID
		ORDER BY ISNULL(RENDvSOR.BizSorID,2147483647), RENDvFEJ.Kelt, RENDvSOR.Mennyi, RENDvSOR.RendvsorID

		SET @maradek=@mennyi

		OPEN rendvsorcursor
		FETCH rendvsorcursor INTO @rendvsorID,@rendvsorMennyi
		WHILE @@Fetch_status=0
		BEGIN
			--ha nincs mr bevtelezett mennyisg
			IF @maradek=0
			BEGIN
				UPDATE RENDvSOR SET BizSorID=NULL WHERE RendvsorID=@rendvsorID
			END
			--kevesebb vagy egyenl a rendelt mennyisg, mint a bevtelezett mennyisg
			ELSE IF @rendvsorMennyi<=@maradek
			BEGIN
				UPDATE RENDVSOR SET BizSorID=@bizsorID WHERE RendvsorID=@rendvsorID
				SET @maradek=@maradek-@rendvsorMennyi
			END
			--tbb a rendelt mennyisg, mint a bevtelezs -> soroszts
			ELSE
			BEGIN
				UPDATE RENDVSOR SET BizSorID=@bizsorID, Mennyi=@maradek WHERE RendvsorID=@rendvsorID

				INSERT INTO RENDVSOR (RendvfejID, CikkID, szolgID, Mennyi, Egysegar, Ehatarido, Rtipus, Megjegyz, Afaid, kedvezs, RsorMeid, RaktID,MunkalapID) 
									 (SELECT RendvfejID, CikkID, szolgID, @rendvsorMennyi - @maradek, Egysegar, Ehatarido, Rtipus, Megjegyz, Afaid, kedvezs, RsorMeid, RaktID,MunkalapID FROM RENDVSOR WHERE RendvsorID = @rendvsorID)

				SET @maradek=0
			END

			FETCH rendvsorcursor INTO @rendvsorID,@rendvsorMennyi
		END
		CLOSE rendvsorcursor
		DEALLOCATE rendvsorcursor
     END
	
end






--res mozgsnem szmlaszm vagy raktrkzi kiadsnl vagy (a clraktr nem bizomnyosi s raktrkzi bevt) vagy bizomnyos raktrt nem kell knyvelni
IF LTRIM(ISNULL(@szSzam,''))='' OR (@specKod='A' and @celraktarTip<>'B') OR (@celRaktarTip <> 'B' AND @specKod='B') OR (@raktarTip='B' and @specKod<>'A')
	RETURN

DECLARE @rgznaploiD smallint, @sorszam int,	@Bbizszam char(12),	@naploid smallint, @jogcimID int,
		@sztukorid int,	@ertek money, @tetelsorID int, @mozgszID int,
		@konyvmod char(1), @m5os bit

if ISNULL(@uzemekID,0)=0
   select @uzemekID=uzemekid from sztukor where sztukorid=@mszszID

if isnull(@tetelfejID,0)=0 or (select COUNT(*) from tetelfej where tetelfejid=@tetelfejID and isnull(@tetelfejID,0)>0)=0
begin
  select @naploid=naploid from naplofej where naplotip='X' and bkod='K' and konyvev=@konyvEv

  select @rgznaploid=max(rgzID) from RGZNAPLO
         where NaploID=@naploID and Zart='N' and  left(neve,7)=right('0'+ltrim(str(month(@bizkelt),2)),2)+'.havi'
   if isnull(@rgznaploid,0)=0
         begin
           select @rgzneve='XK'+right(rtrim(evek.Ev),2)+'-'+right('00'+ltrim(str(month(@bizkelt),2)),2)+
		'-'+right('000'+ltrim(str(naplofej.RgzSorszam,3)),3)
              from naplofej left join evek on naplofej.KonyvEv=evek.evekID where naploID=@naploID 
           if right(@rgzneve,1)='*' 
                select @rgzneve='XK'+right(rtrim(evek.Ev),2)+'-'+right('00'+ltrim(str(month(@bizkelt),2)),2)+str(naplofej.RgzSorszam,4)
              from naplofej left join evek on naplofej.KonyvEv=evek.evekID where naploID=@naploID

           insert into RGZNAPLO (NaploID,creUser,Neve,Zart,rgzneve)
             values (@naploID,@creUser,right('0'+ltrim(str(month(@bizkelt),2)),2)+'.havi','N',@rgzneve)
           select @rgznaploid=max(rgzID) from RGZNAPLO
             where NaploID=@naploID and Zart='N' and  left(neve,7)=right('0'+ltrim(str(month(@bizkelt),2)),2)+'.havi'
         end
  

   

update naplofej set sorszam=sorszam+1 where naploID=@naploID
  select  @bbizszam=naplofej.naplotip+naplofej.bkod+right(rtrim(evek.Ev),2)+'-'+right('00000'+ltrim(str(sorszam,naplofej.bizhosz)),naplofej.bizhosz)
           from naplofej
              left join evek on naplofej.KonyvEv=evek.evekID
              where naploID=@naploID 
  insert into tetelfej (naploID,bizkelt,bbizszam,bizszam,CreUser,tetelszam,KonyvEv,Naplotip,RgzID  ) 
             values(@naploID,@bizKelt,@bbizszam,@bizszam,@creUser,0,@konyvEv,'X',@rgznaploid)
  select @tetelfejID=SCOPE_IDENTITY()   
  update bizfej set tetelfejID=@tetelfejID where bizfejid=@bizfejID
end

select @mozgszID=sztukorid from sztukor where szsz=@szSzam and KonyvEv=@konyvEv
select @jogcimID=jogcimID from jogcim where jogcimKOD='JOKER' and KOnyvEv=@konyvEv


select @konyvelve=konyvelve from tetelfej where tetelfejid=@tetelfejid
if @konyvelve='I'
  exec sp_konyvel_back @tetelfejid


IF CURSOR_STATUS('global','kbizkont')>=-1
	DEALLOCATE kbizkont



declare kbizkont scroll cursor for
select isnull(sztukorid,0) as sztukorid,sum(ertek) as ertek 
from bizsor 
left join cikk on bizsor.cikkID=cikk.cikkID
left join cikkcsop on cikk.cikkcsopID=cikkcsop.cikkcsopID 
left join sztukor on sztukor.szsz=cikkcsop.keszSzam 
INNER JOIN BIZFEJ ON BIZFEJ.BizfejID=BIZSOR.BizfejID
INNER JOIN MOZGNEM ON MOZGNEM.MozgnemID=BIZFEJ.mozgnemID
INNER JOIN RAKTAR ON RAKTAR.RaktarID=BIZSOR.RaktarID
LEFT JOIN RAKTAR CELRAKTAR ON CELRAKTAR.RaktarID=BIZSOR.CelRaktar
where sztukor.KonyvEv=@konyvEv and bizsor.bizfejID=@bizfejID AND RAKTAR.RaktarTip in ('D','S') AND --sajt raktrba
	  ((ISNULL(MOZGNEM.SpecKod, '') NOT IN ('A','B')) OR (CELRAKTAR.RaktarTip='B' AND MOZGNEM.SpecKod='B')  or  (mozgnem.speckod='A' and celraktar.raktartip='B'   )  ) --nem raktrkzi, vagy raktrkzi de bizomnyosibl tvett
group by sztukorID

set @elsz_ert=0
set @sorszam=1
set @konyvmod =left(dbo.fc_setup('R', @konyvEv,121),1)

open kbizkont
fetch kbizkont into @sztukorid,@ertek
 while @@Fetch_status=0
 begin
   set @tetelsorID=null
   set @ktgfelID=null
   set @ertek=isnull(@ertek,0) --=round(@ertek,0)
   set @elsz_ert=@elsz_ert+@ertek
   if @irany='N'
     select @tetelsorID=tetelsorID from tetelsor 
     where tetelfejID=@tetelfejID and isnull(szszID,0)=@sztukorid
   else
     select @tetelsorID=tetelsorID from tetelsor 
     where tetelfejID=@tetelfejID and isnull(eszszID,0)=@sztukorid
   ---------------------------------------------------------------
   if @konyvmod='1'
     begin
     if isnull(@tetelsorID,-1)=-1
       begin
        if @irany='N'
          insert into tetelsor (tetelfejid,jogcimID,szallitoID,szszID,eszszID,tartozik,tkjel,bizszov,kvjel,osszeg,AfaOsszeg,SOrszam,uzemekid,eszkozid)
          values(@tetelfejID,@jogcimID,@szallitoID,@sztukorID,@mozgszID,@ertek,'True',@bizszov,'A',@ertek,0,@sorszam,@uzemekID,@eszkozid)
        else
         insert into tetelsor (tetelfejid,jogcimID,szallitoID,szszID,eszszID,tartozik,tkjel,bizszov,kvjel,osszeg,AfaOsszeg,Sorszam,uzemekid,eszkozid)
          values(@tetelfejID,@jogcimID,@szallitoID,@mozgszID,@sztukorID,@ertek,'True',@bizszov,'A',@ertek,0,@sorszam,@uzemekID,@eszkozid) 
        select @tetelsorID=SCOPE_IDENTITY()
      end   
     else
       update tetelsor set tartozik=@ertek,osszeg=@ertek,jogcimID=@jogcimID,szallitoID=@szallitoID,sorszam=@sorszam,eszkozid=@eszkozid where tetelsorid=@tetelsorID

      ---- ktg feloszts   
      if isnull(@ktghelyID,0)>0 or isnull(@munkszamID,0)>0 or @mszszID>0
        begin
          select @ktgfelID=ktgfelID from ktg_fel where tetelsorID=@tetelsorID
          if isnull(@ktgfelid,-1)=-1
             insert into ktg_fel (tetelsorID,ktghelyID,munkid,mszszid,osszeg) values (@tetelsorID,@ktghelyID,@munkszamID,@mszszID,@ertek)
         else
           update ktg_fel set ktghelyid=@ktghelyID,munkid=@munkszamID,osszeg=@ertek, mszszid=@mszszID where ktgfelID=@ktgfelID
       end
     end
-----------------------------------------------------------------------------
   if @konyvmod='3' 
     begin
      set  @m5os='False'  
      if left(@szSzam,1)='5'    -----or left(@szSzam,1)='8'
          set @m5os='True'
      if isnull(@tetelsorID,-1)=-1
       begin
        if @irany='N'
          insert into tetelsor (tetelfejid,jogcimID,szallitoID,szszID,eszszID,tartozik,tkjel,bizszov,kvjel,osszeg,AfaOsszeg,Sorszam,uzemekid,eszkozid)
          values(@tetelfejID,@jogcimID,@szallitoID,@sztukorID,dbo.iiflc(@m5os,@mszszID,@mozgszID),@ertek,'True',@bizszov,'A',@ertek,0,@sorszam,@uzemekID,@eszkozid)
        else
         insert into tetelsor (tetelfejid,jogcimID,szallitoID,szszID,eszszID,tartozik,tkjel,bizszov,kvjel,osszeg,AfaOsszeg,Sorszam,uzemekid,eszkozid)
          values(@tetelfejID,@jogcimID,@szallitoID,dbo.iiflc(@m5os,@mszszID,@mozgszID),@sztukorID,@ertek,'True',@bizszov,'A',@ertek,0,@sorszam,@uzemekID,@eszkozid) 
        select @tetelsorID=SCOPE_IDENTITY()
       end   
     else  --- mdosts
       update tetelsor set tartozik=@ertek,osszeg=@ertek,jogcimID=@jogcimID,szallitoID=@szallitoID,sorszam=@sorszam,eszkozid=@eszkozid where tetelsorid=@tetelsorID
      --- msodlagos
       if (@m5os='true' or left(@szSzam,1)>'7' ) and @tetelsorID>0
          begin             
            select @ktgfelID=ktgfelID from ktg_fel where tetelsorID=@tetelsorID
           
           if isnull(@ktgfelid,-1)=-1
               if left(@szSzam,1)<'8'
                   insert into ktg_fel (tetelsorID,ktghelyID,munkid,mszszid,osszeg) values (@tetelsorID,@ktghelyID,@munkszamID,@mozgszID,@ertek)
               else
                   insert into ktg_fel (tetelsorID,ktghelyID,munkid,osszeg) values (@tetelsorID,@ktghelyID,@munkszamID,@ertek)
 
            else
               if left(@szSzam,1)<'8'
                  update ktg_fel set ktghelyid=@ktghelyID,munkid=@munkszamID,osszeg=@ertek, mszszid=@mozgszID where ktgfelID=@ktgfelID
               else
                  update ktg_fel set ktghelyid=@ktghelyID,munkid=@munkszamID,osszeg=@ertek where ktgfelID=@ktgfelID

      
          end

     end   
   
   set @sorszam=@sorszam+1
   fetch kbizkont into @sztukorid,@ertek
 end
 
  ------------- felesleges ttelsor trlse -----
  IF CURSOR_STATUS('global','ktetelsor')>=-1
	DEALLOCATE ktetelsor
   if @irany='N'
	declare ktetelsor cursor for     
	select tetelsorID,szszID as sztukorid from tetelsor 
        where tetelfejID=@tetelfejID 
   else
	declare ktetelsor cursor for     
     select tetelsorID,eszszid as sztukorid from tetelsor 
     where tetelfejID=@tetelfejID 
 open ktetelsor

fetch ktetelsor into @tetelsorid,@sztukorid
 while @@Fetch_status=0
 begin
 set @van=0
     fetch first from kbizkont into @sztukorid2,@ertek
	 while @@FETCH_STATUS=0
	 begin
       if @sztukorid=@sztukorid2
	      set @van=1
	   fetch  kbizkont into @sztukorid2,@ertek
     end
	 if @van=0
           delete from tetelsor where tetelsorid=@tetelsorid
     fetch ktetelsor into @tetelsorid,@sztukorid
 end
 close ktetelsor
 deallocate ktetelsor

 close kbizkont
 deallocate kbizkont
 update tetelfej set tetelszam=@sorszam-1,ekelt=@bizKelt where tetelfejID=@tetelfejID
 if @konyvelve='I'
   exec sp_konyvel @tetelfejid