CREATE TRIGGER [dbo].[tr_bizsorp_insert] ON [dbo].[BIZSORP]
FOR INSERT, UPDATE, DELETE
AS

DECLARE @forrasKeszletPID int, @celKeszletPID int, @pMennyi numeric(10,3), @bMennyi numeric(10,3), @keszletID int, @rendvsorID int, @forrasGyujto bit, @celGyujto bit, @webre bit, @webre2 bit, @keszletFrissit bit = 0, @webUserID smallint, @webUserID2 smallint

--Flex-Fnynl a gyjt polcra pakolst is kszlet vltozsnak kell venni
IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'FLEX') > 0
BEGIN
	--WEB user azonost
	SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

	--WEB user azonost 2
	SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

END

IF ISNULL(@webUserID,'') = '' AND ISNULL(@webUserID2,'') = ''
BEGIN
	DECLARE BizsorpCursor CURSOR FOR

	--DISTINCT mdosts miatt ne legyen 2 sor
	SELECT DISTINCT L.*
	FROM (
		SELECT KeszletpID, KeszletcID, NULL AS 'RendvsorID', NULL AS 'KeszletID', CAST(0 AS bit) AS 'ForrasGyujto', CAST(0 AS bit) AS 'CelGyujto', CAST(0 AS bit) AS 'Webre', CAST(0 AS bit) AS 'Webre2' FROM inserted
		UNION
		SELECT KeszletpID, KeszletcID, NULL AS 'RendvsorID', NULL AS 'KeszletID', CAST(0 AS bit) AS 'ForrasGyujto', CAST(0 AS bit) AS 'CelGyujto', CAST(0 AS bit) AS 'Webre', CAST(0 AS bit) AS 'Webre2' FROM deleted) L
END
ELSE
BEGIN
	DECLARE BizsorpCursor CURSOR FOR

	--DISTINCT mdosts miatt ne legyen 2 sor
	SELECT L2.KeszletpID, L2.KeszletcID, L2.RendvsorID, L2.KeszletID,
		(CASE WHEN ISNULL(RAKTAR.Megszunt,0) = 0 AND RAKTAR.WebShop = 1 AND ISNULL(CIKK.Megszunt,0) = 0 AND (CIKK.Webre = 1 OR CIKK.Webre2 = 1) AND Cikkhiercs IS NOT NULL THEN (CASE WHEN L2.ForrasRaktarPID = RAKTAR.GyujtoPID OR L2.ForrasRaktarPID = RAKTAR.RendPID OR L2.ForrasRaktarPID = RAKTAR.BoltiPID OR L2.ForrasRaktarPID = RAKTAR.WEBPID OR L2.ForrasRaktarPID = RAKTAR.EladPID THEN 1 ELSE 0 END) ELSE 0 END) AS 'ForrasGyujto',
		(CASE WHEN ISNULL(RAKTAR.Megszunt,0) = 0 AND RAKTAR.WebShop = 1 AND ISNULL(CIKK.Megszunt,0) = 0 AND (CIKK.Webre = 1 OR CIKK.Webre2 = 1) AND Cikkhiercs IS NOT NULL THEN (CASE WHEN L2.CelRaktarPID = RAKTAR.GyujtoPID OR L2.CelRaktarPID = RAKTAR.RendPID OR L2.CelRaktarPID = RAKTAR.BoltiPID OR L2.CelRaktarPID = RAKTAR.WEBPID OR L2.CelRaktarPID = RAKTAR.EladPID THEN 1 ELSE 0 END) ELSE 0 END) AS 'CelGyujto',
		ISNULL(CIKK.Webre,0) AS 'Webre', ISNULL(CIKK.Webre2,0) AS 'Webre2'
	FROM (
		SELECT DISTINCT L.KeszletpID, L.KeszletcID, L.RendvsorID, ISNULL(KESZLETP.KeszletID, CEL_KESZLETP.KeszletID) AS 'KeszletID', KESZLETP.RaktarPID AS 'ForrasRaktarPID', CEL_KESZLETP.RaktarPID AS 'CelRaktarPID' 
		FROM (
			SELECT KeszletpID, KeszletcID, RendvsorID FROM inserted
			UNION
			SELECT KeszletpID, KeszletcID, RendvsorID FROM deleted) L
		LEFT JOIN KESZLETP ON KESZLETP.KeszletPID = L.KeszletpID
		LEFT JOIN KESZLETP CEL_KESZLETP ON CEL_KESZLETP.KeszletPID = L.KeszletcID) L2
	LEFT JOIN KESZLET ON KESZLET.KeszletID = L2.KeszletID
	LEFT JOIN RAKTAR ON RAKTAR.RaktarID = KESZLET.RaktarID
	LEFT JOIN CIKK ON CIKK.CikkID = KESZLET.CikkID
END

OPEN BizsorpCursor

FETCH NEXT FROM BizsorpCursor INTO @forrasKeszletPID, @celKeszletPID, @rendvsorID, @keszletID, @forrasGyujto, @celGyujto, @webre, @webre2

WHILE @@FETCH_STATUS = 0
BEGIN
	IF @forrasKeszletPID IS NOT NULL
	BEGIN
		SELECT @pMennyi = ISNULL(SUM(PMennyi),0), @bMennyi = ISNULL(SUM(CASE WHEN BMennyi IS NULL THEN 0 ELSE BMennyi - ISNULL(PMennyi,0) END),0) FROM BIZSORP WHERE KeszletcID = @forrasKeszletPID
		SELECT @pMennyi = @pMennyi - ISNULL(SUM(PMennyi),0), @bMennyi = @bMennyi - ISNULL(SUM(CASE WHEN BMennyi IS NULL THEN 0 ELSE BMennyi - ISNULL(PMennyi,0) END),0) FROM BIZSORP WHERE KeszletpID = @forrasKeszletPID

		UPDATE KESZLETP SET Mennyi = @pMennyi, BevAlatt = @bMennyi WHERE KESZLETP.KeszletPID = @forrasKeszletPID

		--Ha forrs trhely gyjt s nem gyjtrl gyjtre helyezte s nem eladta (van cl trhely)
		IF @forrasGyujto = 1 AND @celGyujto = 0 AND @celKeszletPID IS NOT NULL
			SET @keszletFrissit = 1
	END

	IF @celKeszletPID IS NOT NULL
	BEGIN
		SELECT @pMennyi = ISNULL(SUM(PMennyi),0), @bMennyi = ISNULL(SUM(CASE WHEN BMennyi IS NULL THEN 0 ELSE BMennyi - ISNULL(PMennyi,0) END),0) FROM BIZSORP WHERE KeszletcID = @celKeszletPID
		SELECT @pMennyi = @pMennyi - ISNULL(SUM(PMennyi),0), @bMennyi = @bMennyi - ISNULL(SUM(CASE WHEN BMennyi IS NULL THEN 0 ELSE BMennyi - ISNULL(PMennyi,0) END),0) FROM BIZSORP WHERE KeszletpID = @celKeszletPID

		UPDATE KESZLETP SET Mennyi = @pMennyi, BevAlatt = @bMennyi WHERE KESZLETP.KeszletPID = @celKeszletPID

		--Ha mg nincs kszletfrissts s a cl trhely gyjt s nem gyjtrl gyjtre helyezte s nem rendelsbl leraks, akkor kszlet vltozs
		IF @keszletFrissit = 0 AND @celGyujto = 1 AND @forrasGyujto = 0 AND @rendvsorID IS NULL
			SET @keszletFrissit = 1
	END

	IF @keszletFrissit = 1
	BEGIN
		IF @webre = 1 AND @webUserID <> ''
			INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 62),@keszletID,@webUserID) --Kszlet letlts

		IF @webre2 = 1 AND @webUserID2 <> ''
			INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 62),@keszletID,@webUserID2) --Kszlet letlts
	END

	FETCH NEXT FROM BizsorpCursor INTO @forrasKeszletPID, @celKeszletPID, @rendvsorID, @keszletID, @forrasGyujto, @celGyujto, @webre, @webre2
END

CLOSE BizsorpCursor
DEALLOCATE BizsorpCursor