CREATE TRIGGER [dbo].[tr_cikk_modify] ON [dbo].[CIKK] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

IF @webUserID = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') > 0
	RETURN

DECLARE @cikkID int, @cikkNev varchar(50), @cikkTipus varchar(50), @meID tinyint, @cikkCsopID smallint,
		@cEgysAr1 money, @cEgysAr1B money, @cEgysAr2 money, @cEgysAr2B money, @cEgysAr3 money, 
		@cEgysAr3B money, @afaID tinyint, @vtsz varchar(10), @cikkhiercs smallint, @egyeb varchar(800),
		@mGyartokID smallint, @ujdonsagIg date, @videoLink varchar(100), @cikkHelyID int, @rezsis bit,
		@megszunt bit, @webre bit, @kiszEgyseg float, @valtozat varchar(100), @kifuto bit, @csakUzlet bit,
		@webLeiras varchar(MAX),

		@dCikkID int, @dCikkNev varchar(50), @dCikkTipus varchar(50), @dMeID tinyint, @dCikkCsopID smallint,
		@dCEgysAr1 money, @dCEgysAr1B money, @dCEgysAr2 money, @dCEgysAr2B money, @dCEgysAr3 money, 
		@dCEgysAr3B money, @dAfaID tinyint, @dVtsz varchar(10), @dCikkhiercs smallint, @dEgyeb varchar(800),
		@dMGyartokID smallint, @dUjdonsagig date, @dVideoLink varchar(100), @dCikkHelyID int, @dRezsis bit,
		@dMegszunt bit, @dWebre bit, @dKiszEgyseg float, @dValtozat varchar(100), @dKifuto bit, @dCsakUzlet bit,
		@dWebLeiras varchar(MAX),

		@gcmMuvInt int, @keszletFrissit bit = 0

SELECT @cikkID=inserted.CikkID, @cikkNev=inserted.CikkNev, @cikkTipus=inserted.CikkTipus, @meID=inserted.MeID, @cikkCsopID=inserted.CikkCsopID,
	   @cEgysAr1=ISNULL(WEBARAK.WEgysar,inserted.CEgysAr1), @cEgysAr1B=ISNULL(WEBARAK.WEgysarB,inserted.CEgysAr1B), @cEgysAr2=inserted.CEgysAr2, @cEgysAr2B=inserted.CEgysAr2B, @cEgysAr3=inserted.CEgysAr3,
	   @cEgysAr3B=inserted.CEgysAr3B, @afaID=inserted.AfaID, @vtsz=inserted.VTSZ, @cikkhiercs=inserted.Cikkhiercs, @egyeb=inserted.Egyeb,
	   @mGyartokID=inserted.MgyartokID, @ujdonsagIg=inserted.UjdonsagIg, @videoLink=inserted.VideoLink, @cikkHelyID=inserted.CikkHelyID, @rezsis=ISNULL(inserted.Rezsis,0),
	   @megszunt=ISNULL(inserted.Megszunt,0), @webre=ISNULL(inserted.Webre,0), @kiszEgyseg=inserted.KiszEgyseg, @valtozat=inserted.Valtozat, @kifuto=ISNULL(inserted.Kifuto,0), @csakUzlet=ISNULL(inserted.CsakUzlet,0),
	   @webLeiras=WebLeiras
FROM inserted
	 LEFT JOIN WEBARAK ON WEBARAK.CikkID = inserted.CikkID

SELECT @dCikkID=deleted.CikkID, @dCikkNev=deleted.CikkNev, @dCikkTipus=deleted.CikkTipus, @dMeID=deleted.MeID, @dCikkCsopID=deleted.CikkCsopID,
	   @dCEgysAr1=ISNULL(WEBARAK.WEgysar,deleted.CEgysAr1), @dCEgysAr1B=ISNULL(WEBARAK.WEgysarB,deleted.CEgysAr1B), @dCEgysAr2=deleted.CEgysAr2, @dCEgysAr2B=deleted.CEgysAr2B, @dCEgysAr3=deleted.CEgysAr3,
	   @dCEgysAr3B=deleted.CEgysAr3B, @dAfaID=deleted.AfaID, @dVtsz=deleted.VTSZ, @dCikkhiercs=deleted.Cikkhiercs, @dEgyeb=deleted.Egyeb,
	   @dMGyartokID=deleted.MgyartokID, @dUjdonsagIg=deleted.UjdonsagIg, @dVideoLink=deleted.VideoLink, @dCikkHelyID=deleted.CikkHelyID, @dRezsis=ISNULL(deleted.Rezsis,0),
	   @dMegszunt=ISNULL(deleted.Megszunt,0), @dWebre=ISNULL(deleted.Webre,0), @dKiszEgyseg=deleted.KiszEgyseg, @dValtozat=deleted.Valtozat, @dKifuto=ISNULL(deleted.Kifuto,0), @dCsakUzlet=ISNULL(deleted.CsakUzlet,0),
	   @dWebLeiras=WebLeiras
FROM deleted
	 LEFT JOIN WEBARAK ON WEBARAK.CikkID = deleted.CikkID

--Trls vagy (mdosts s (megszntt teszi vagy hierarchia csoportot trli))
IF (@cikkID IS NULL AND @dCikkID IS NOT NULL) OR (@cikkID IS NOT NULL AND @dCikkID IS NOT NULL AND ((@dMegszunt = 0 AND @megszunt = 1) OR (@dCikkhiercs IS NOT NULL AND @cikkhiercs IS NULL) OR (@dWebre = 1 AND @webre = 0)))
BEGIN
	--Megsznt, hierarchia nlkli vagy nem webes cikk trlst nem kell kikldeni
	IF @dMegszunt = 1 OR @dCikkhiercs IS NULL OR @dWebre = 0
		RETURN

	SET @gcmMuvInt = 33 -- Cikk trls
	SET @cikkID = @dCikkID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 32) AND UserID = @webUserID
END
--j vagy mdosts
ELSE
BEGIN
	SET @gcmMuvInt = 32 --Cikk letlts

	--Mdosts
	IF @dCikkID IS NOT NULL
	BEGIN

		--Megsznt, hierarchia nlkli vagy nem webes cikk mdostst nem kell kikldeni
		IF @megszunt = 1 OR @cikkhiercs IS NULL OR @webre = 0
			RETURN

		--Ha nem vltozott az tadott rtkek valamelyike
		IF @cikkNev = @dCikkNev AND ISNULL(@cikkTipus,'') = ISNULL(@dCikkTipus,'') AND @meID = @dMeID AND @cikkCsopID = @dCikkCsopID AND
		   @cEgysAr1 = @dCEgysAr1 AND @cEgysAr1B = @dCEgysAr1B AND @cEgysAr2 = @dCEgysAr2 AND @cEgysAr2B = @dCEgysAr2B AND @cEgysAr3 = @dCEgysAr3 AND 
		   @cEgysAr3B = @dCEgysAr3B AND @afaID = @dAfaID AND ISNULL(@vtsz,'') = ISNULL(@dVtsz,'') AND ISNULL(@cikkhiercs,0) = ISNULL(@dCikkhiercs,0) AND ISNULL(@egyeb,'') = ISNULL(@dEgyeb,'') AND
		   ISNULL(@mGyartokID,0) = ISNULL(@dMGyartokID,0) AND ISNULL(@ujdonsagIg,'1900.01.01') = ISNULL(@dUjdonsagIg,'1900.01.01') AND ISNULL(@videoLink,'') = ISNULL(@dVideoLink,'') AND ISNULL(@cikkHelyID,0) = ISNULL(@dCikkHelyID,0) AND @rezsis = @dRezsis AND 
		   @megszunt = @dMegszunt AND @webre = @dWebre AND ISNULL(@kiszEgyseg,0) = ISNULL(@dKiszEgyseg,0) AND ISNULL(@valtozat,'') = ISNULL(@dValtozat,'') AND @kifuto = @dKifuto AND @csakUzlet = @dCsakUzlet AND
		   @webLeiras = @dWebLeiras
		RETURN

		--Ha mdostssal most kerl webre
		IF @dMegszunt = 1 OR @dCikkhiercs IS NULL OR @dWebre = 0
			SET @keszletFrissit = 1
	END
	--j
	ELSE
	BEGIN
		--Megsznt vagy hierarchia nlkli cikk rgztst nem kell kikldeni
		IF @megszunt = 1 OR @cikkhiercs IS NULL OR @webre = 0
			RETURN
	END
END

INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkID,@webUserID)

IF @keszletFrissit = 1
BEGIN
	DECLARE @keszletID int

	DECLARE KeszletCursor CURSOR FOR

	SELECT KESZLET.KeszletID
	FROM KESZLET
			INNER JOIN RAKTAR ON RAKTAR.RaktarID = KESZLET.RaktarID
	WHERE ISNULL(RAKTAR.Megszunt,0) = 0 AND RAKTAR.WebShop = 1 AND KESZLET.CikkID = @cikkID
	ORDER BY KESZLET.KeszletID

	OPEN KeszletCursor

	FETCH NEXT FROM KeszletCursor INTO @keszletID
	WHILE @@FETCH_STATUS = 0
	BEGIN
		INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 62),@keszletID,@webUserID) --Kszlet letlts

		FETCH NEXT FROM KeszletCursor INTO @keszletID
	END

	CLOSE KeszletCursor
	DEALLOCATE KeszletCursor
END