CREATE TRIGGER [dbo].[tr_cikkakc_modify2] ON [dbo].[CIKKAKC] FOR INSERT,UPDATE,DELETE
AS
DECLARE @userID smallint

--Digitlis cmke user azonost
SELECT @userID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 228

IF @userID = ''
	RETURN

DECLARE @vonalkodID int, @cikkAkcID int, @akcioID smallint, @cikkID int, @egysarArB money,

		@dCikkAkcID int, @dAkcioID smallint, @dCikkID int, @dEgysarArB money

SELECT @cikkAkcID=CikkAkcID, @akcioID=AkcioID, @cikkID=CikkID, @egysarArB = EgysarArb FROM inserted

SELECT @dCikkAkcID=CikkAkcID, @dAkcioID=AkcioID, @dCikkID=CikkID, @dEgysarArB = EgysarArb FROM deleted

--j vagy mdosts
IF @cikkAkcID IS NOT NULL
BEGIN
	--Nem aktulis akci
	IF (SELECT COUNT(*) FROM AKCIO WHERE AkcioID = @akcioID AND CAST(GETDATE() AS DATE) BETWEEN Tol AND Ig AND ISNULL(TelepID,1) = 1) = 0
		RETURN

	--Mdosts
	IF @dCikkAkcID IS NOT NULL
	BEGIN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @cikkID = @dCikkID AND @egysarArB = @dEgysarArB
			RETURN

		--ha megvltozott a cikk, az eredeti cikk jboli letltse
		IF @cikkID <> @dCikkID
		BEGIN
			DECLARE VonalkodCursor CURSOR FOR

				SELECT VONALKOD.VonalkodID
				FROM VONALKOD
					 INNER JOIN CIKK ON CIKK.CikkID = VONALKOD.CikkID
				WHERE CIKK.CikkID = @dCikkID

			OPEN VonalkodCursor

			FETCH NEXT FROM VonalkodCursor INTO @vonalkodID

			WHILE @@FETCH_STATUS = 0
			BEGIN
				INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 32),@vonalkodID,@userID)

				FETCH NEXT FROM VonalkodCursor INTO @vonalkodID
			END

			CLOSE VonalkodCursor
			DEALLOCATE VonalkodCursor
		END
	END
END
ELSE
BEGIN
	--Nem aktulis akci
	IF (SELECT COUNT(*) FROM AKCIO WHERE AkcioID = @dAkcioID AND CAST(GETDATE() AS DATE) BETWEEN Tol AND Ig AND ISNULL(TelepID,1) = 1) = 0
		RETURN

	SET @cikkID = @dCikkID
END

DECLARE VonalkodCursor CURSOR FOR

	SELECT VONALKOD.VonalkodID
	FROM VONALKOD
		 INNER JOIN CIKK ON CIKK.CikkID = VONALKOD.CikkID
	WHERE CIKK.CikkID = @cikkID

OPEN VonalkodCursor

FETCH NEXT FROM VonalkodCursor INTO @vonalkodID

WHILE @@FETCH_STATUS = 0
BEGIN
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 32),@vonalkodID,@userID)

	FETCH NEXT FROM VonalkodCursor INTO @vonalkodID
END

CLOSE VonalkodCursor
DEALLOCATE VonalkodCursor