CREATE TRIGGER [dbo].[tr_docnez_update]
   on [dbo].[DOCNEZ] 
   AFTER update
AS 
BEGIN
	declare @docnezid int,@alair bit,@alaird bit,@nextuser smallint,@docID int,@statusz char(1),@kapcstipus int,@irany char(1),@hivatkozas int,@mind int,@postazva date
	declare @megtilt bit,@belsolev bit,@mind2 int,@userid smallint,@szemelyid int,@levelekid int

	SET NOCOUNT ON;

    select @docnezID=inserted.docnezID,@alair=alair,@nextuser=nextuser,@docid=docID,@megtilt=isnull(megtilt,'False'),@userid=userid from inserted
    select @alaird=alair from deleted

    --ha alrs trtnt s van kvetkez alr
	if @alair='True' and @alaird='False' and isnull(@nextuser,0)>0
        begin
		--kvetkez alr lthatja, ha eltte mindenki alrta (nincs mg olyan aki nem rta volna al s nem utastotta volna el eltte)
		if (SELECT COUNT(*) FROM DOCNEZ WHERE DocID=@docID AND NextUser=@nextuser AND ISNULL(Alair,0)=0 AND ISNULL(Nemenyem,0)=0) = 0
			update docnez set lathatja='True',lathatTime=getdate() where docid=@docID and userID=@nextuser
	end

	--mindenki alrta
	select @mind=count(userid) from docnez where docid=@docID and isnull(alair,'False')='False' and isnull(nemenyem,'False')='False'

	--ha alrs trtnt s nincs mr tovbbi alr
	if @alair='True' and @alaird='False' and @mind=0
	begin
		select @kapcstipus=kapcstipus from docfej where docID=@docid

        --Szllti szmla
        if @kapcstipus=1
		begin
			select @statusz=statusz from iktat where docID=@docid
			
			--Berkezett vagy Visszautastott (megtilts utn jbl alr) --> Igazolt
			if @statusz='B' or @statusz='V'
				update iktat set statusz='I' where docID=@docid
		end

		--Szllti rendelsek
		else if @kapcstipus=5
		begin
			select @statusz=statusz from rendsfej where docID=@docid
			
			--Alrsra vr --> Engedlyezve
			if @statusz='A'
				update rendsfej set statusz='E' where docID=@docid
		end

		--Levelek
		else if @kapcstipus=6
		begin
			select @statusz=statusz,@hivatkozas=hivatkozas,@belsolev=belsolev,@irany=irany,@postazva=Postazva,@levelekid=levelekid from levelek where docID=@docid

			--bejv levl
			if @irany='B'
			begin
				--rkeztetve vagy Alrsra vr --> Felelsnl
				if @statusz='' or @statusz='A'
					update levelek set statusz='F' where docID=@docid
			end
			--kimen levl
			else
			begin
				--bels levelezs --> Elkldtt
				if isnull(@belsolev,'False')='True'
					update levelek set statusz='E' where docID=@docid
				--nem Elkldtt
				else if @statusz<>'E'
				begin
					--nincs mg postzs dtuma
					if @postazva IS NULL
					begin
						--Postzhat
						update levelek set statusz='P' where docID=@docid

						--elzmny levl --> Postzhat
						if isnull(@hivatkozas,0)>0
							update levelek set statusz='P' where levelekID=@hivatkozas or kovetkezo=@levelekid
					end
					--van mr postzs dtuma (postzva dtumot megadta, majd ksbb csatolta a dokumentumot alrsi ttal)
					else
					begin
						--Elkldtt
						update levelek set statusz='E' where docID=@docid

						--elzmny levl --> Megvlaszolt
						if isnull(@hivatkozas,0)>0
							update levelek set statusz='M' where levelekID=@hivatkozas or kovetkezo=@levelekid
					end
				end
			end
		end

		--Brlap
		else if @kapcstipus=10
		begin
			update berleido set alairva=1 where docID=@docid
		end
		
		-- Labor jegyzknyv
		if @kapcstipus=22
                   begin

		       select @szemelyid=szemelyid from users where userid=@userid	
                       update lbjegyzk set szemelyID=@szemelyid,lezart=1 where docid=@docid
		   end


		--Rendels igny
		if @kapcstipus=15
		begin
			select @statusz=statusz from igenyfej where docID=@docid

			--Alrsra vr vagy Letiltva --> Engedlyezett
			if @statusz='A' OR @statusz='L'
				update igenyfej set statusz='E' where docID=@docid
		end
	end

	--megtilt
	if @megtilt='True' 
	begin
		select @kapcstipus=kapcstipus from docfej where docID=@docid          

		--Szllti szmla
		if @kapcstipus=1
		begin
			select @statusz=statusz from iktat where docID=@docid

			--nem Visszautastott s nem Megkifogsolt --> Visszautastott
			if @statusz<>'V' and @statusz<>'M'
				update iktat set statusz='V' where docID=@docid
		end

		--Rendels igny
		else if @kapcstipus=15
		begin
			select @statusz=statusz from igenyfej where docID=@docid

			--Alrsra vr -> Letiltva
			if @statusz='A'
				update igenyfej set statusz='L' where docID=@docid
		end
	end

	--Szllti rajnlat
	if @kapcstipus=7
	begin
		select @mind2=count(userid) from docnez where docid=@docID and (isnull(alair,'False')='False' and isnull(megtilt,'False')='False') and isnull(nemenyem,'False')='False'

		--mindenki adott vlaszt (alrta vagy megtiltotta)
		if @mind2=0
		begin
			--mindenki alrta
			if @mind=0
				update arajsfej set statusz='E' where docID=@docid
			else
				update arajsfej set statusz='D' where docID=@docid            
		end
	end
END