CREATE TRIGGER [dbo].[tr_kedeny_modify] ON [dbo].[KEDENY]
FOR INSERT, UPDATE, DELETE
AS 
BEGIN
BEGIN TRY
	DECLARE @kedenyID int, @kedenyekID smallint, @kukauritID smallint, @szolgID smallint, @RFCHIPID int, @szlaMod char(1), @korrekcio numeric(5,4), @tol date, @ig date, @statusz smallint, @szelektiv bit,
			@dKedenyID int, @dKedenyekID smallint, @dKukauritID smallint, @dSzolgID smallint, @dRFCHIPID int, @dSzlaMod char(1), @dKorrekcio numeric(5,4), @dTol date, @dIg date, @dStatusz smallint, @dSzelektiv bit,
			@webUserID smallint, @vevoID int, @szghelyID int, @varosID smallint, @utcaID smallint, @koztertpID smallint
			
	--WEB user azonost
	SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

	IF @webUserID = ''
		RETURN

	IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') = 0
		RETURN
	
	IF CURSOR_STATUS('global','KedenyCursor')>=-1
	BEGIN
		CLOSE KedenyCursor
		DEALLOCATE KedenyCursor
	END

	DECLARE KedenyCursor CURSOR FOR

	--Mdosts, trls
	SELECT inserted.KEdenyID, deleted.KEdenyID, inserted.Kedenyekid, deleted.Kedenyekid, inserted.kukauritID, deleted.kukauritID, inserted.SzolgID, deleted.SzolgID, 
		   inserted.RFCHIPID, deleted.RFCHIPID, inserted.Szlamod, deleted.Szlamod, inserted.Korrekcio, deleted.Korrekcio, inserted.Tol, deleted.Tol, inserted.Ig, deleted.Ig,
		   inserted.Statusz, deleted.Statusz, KEDENYEK.Szelektiv, DKEDENYEK.Szelektiv, SZGHELY.VevoID, SZGHELY.SzghelyID, VAROSOK.VarosID, UTCAK.UtcaID, UTCAK.KoztertpID
	FROM deleted
		 LEFT JOIN inserted ON inserted.KEdenyID = deleted.KEdenyID
		 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = ISNULL(inserted.SzghelyiD,deleted.SzghelyiD)
		 INNER JOIN VAROSOK ON VAROSOK.VarosID = SZGHELY.SzgVarosID
		 LEFT JOIN UTCAK ON UTCAK.UtcaID = ISNULL(SZGHELY.UrUtcaID, SZGHELY.SzgUtcaID)
		 LEFT JOIN KEDENYEK ON KEDENYEK.KedenyekID = inserted.Kedenyekid
		 LEFT JOIN KEDENYEK DKEDENYEK ON DKEDENYEK.KedenyekID = deleted.Kedenyekid
	WHERE 
		--Mdosts s eltte vagy utna nem szelektv volt
		(inserted.KEdenyID IS NOT NULL AND deleted.KEdenyID IS NOT NULL AND (ISNULL(KEDENYEK.Szelektiv,0) = 0 OR ISNULL(DKEDENYEK.Szelektiv,0) = 0))
		OR
		--Trls s nem szelektv
		(deleted.KEdenyID IS NOT NULL AND ISNULL(DKEDENYEK.Szelektiv,0) = 0)
	GROUP BY inserted.KEdenyID, deleted.KEdenyID, inserted.Kedenyekid, deleted.Kedenyekid, inserted.kukauritID, deleted.kukauritID, inserted.SzolgID, deleted.SzolgID, 
		     inserted.RFCHIPID, deleted.RFCHIPID, inserted.Szlamod, deleted.Szlamod, inserted.Korrekcio, deleted.Korrekcio, inserted.Tol, deleted.Tol, inserted.Ig, deleted.Ig,
		     inserted.Statusz, deleted.Statusz, KEDENYEK.Szelektiv, DKEDENYEK.Szelektiv, SZGHELY.VevoID, SZGHELY.SzghelyID, VAROSOK.VarosID, UTCAK.UtcaID, UTCAK.KoztertpID

	UNION

	--j, mdosts
	SELECT inserted.KEdenyID, deleted.KEdenyID, inserted.Kedenyekid, deleted.Kedenyekid, inserted.kukauritID, deleted.kukauritID, inserted.SzolgID, deleted.SzolgID, 
		   inserted.RFCHIPID, deleted.RFCHIPID, inserted.Szlamod, deleted.Szlamod, inserted.Korrekcio, deleted.Korrekcio, inserted.Tol, deleted.Tol, inserted.Ig, deleted.Ig,
		   inserted.Statusz, deleted.Statusz, KEDENYEK.Szelektiv, DKEDENYEK.Szelektiv, SZGHELY.VevoID, SZGHELY.SzghelyID, VAROSOK.VarosID, UTCAK.UtcaID, UTCAK.KoztertpID
	FROM inserted
		 LEFT JOIN deleted ON deleted.KEdenyID = inserted.KEdenyID
		 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = ISNULL(inserted.SzghelyiD,deleted.SzghelyiD)
		 INNER JOIN VAROSOK ON VAROSOK.VarosID = SZGHELY.SzgVarosID
		 LEFT JOIN UTCAK ON UTCAK.UtcaID = ISNULL(SZGHELY.UrUtcaID, SZGHELY.SzgUtcaID)
		 LEFT JOIN KEDENYEK ON KEDENYEK.KedenyekID = inserted.Kedenyekid
		 LEFT JOIN KEDENYEK DKEDENYEK ON DKEDENYEK.KedenyekID = deleted.Kedenyekid
	WHERE
		--j s szelektv
		(inserted.KEdenyID IS NOT NULL AND deleted.KEdenyID IS NULL AND ISNULL(KEDENYEK.Szelektiv,0) = 0)
		OR
		--Mdosts s eltte vagy utna nem szelektv volt
		(inserted.KEdenyID IS NOT NULL AND deleted.KEdenyID IS NOT NULL AND (ISNULL(KEDENYEK.Szelektiv,0) = 0 OR ISNULL(DKEDENYEK.Szelektiv,0) = 0))
	GROUP BY inserted.KEdenyID, deleted.KEdenyID, inserted.Kedenyekid, deleted.Kedenyekid, inserted.kukauritID, deleted.kukauritID, inserted.SzolgID, deleted.SzolgID, 
		     inserted.RFCHIPID, deleted.RFCHIPID, inserted.Szlamod, deleted.Szlamod, inserted.Korrekcio, deleted.Korrekcio, inserted.Tol, deleted.Tol, inserted.Ig, deleted.Ig,
		     inserted.Statusz, deleted.Statusz, KEDENYEK.Szelektiv, DKEDENYEK.Szelektiv, SZGHELY.VevoID, SZGHELY.SzghelyID, VAROSOK.VarosID, UTCAK.UtcaID, UTCAK.KoztertpID

	OPEN KedenyCursor

	BEGIN TRY
		BEGIN TRAN

		FETCH NEXT FROM KedenyCursor INTO 
			@kedenyID, @dKedenyID, @kedenyekID, @dKedenyekID, @kukauritID, @dKukauritID, @szolgID, @dSzolgID,
			@RFCHIPID, @dRFCHIPID, @szlaMod, @dSzlaMod, @korrekcio, @dKorrekcio, @tol, @dTol, @ig, @dIg,
			@statusz, @dStatusz, @szelektiv, @dSzelektiv, @vevoID, @szghelyID, @varosID, @utcaID, @koztertpID
		WHILE @@FETCH_STATUS = 0
		BEGIN
			--Az j adatokkal vagy a rgi adatokkal a legyjtsbe tartozott s vltozott az tadott rtkek valamelyike
			IF (
				(@statusz = 1 AND @tol <= CAST(GETDATE() AS date) AND (@ig IS NULL OR @ig >= CAST(GETDATE() AS date))) OR 
			    (@dStatusz = 1 AND @dTol <= CAST(GETDATE() AS date) AND (@dIg IS NULL OR @dIg >= CAST(GETDATE() AS date)))
				) AND 
			   (
			    ISNULL(@kedenyekID, 0) <> ISNULL(@dKedenyekID, 0) OR ISNULL(@kukauritID, 0) <> ISNULL(@dKukauritID, 0) OR ISNULL(@szolgID, 0) <> ISNULL(@dSzolgID, 0) OR 
			    /*ISNULL(@RFCHIPID, 0) <> ISNULL(@dRFCHIPID, 0) OR
				20220204, csak RF-IT-tl rkezhet chip mdosts, nem kell visszajelezni
				(TODO: kltzsnl edenyhez chip is msolsra kerl, arrl nem kap rtestst, de nem hasznljk a kltzst)*/ 
				ISNULL(@szlaMod, 0) <> ISNULL(@dSzlaMod, '') OR ISNULL(@korrekcio, '') <> ISNULL(@dKorrekcio, 0) OR 
				ISNULL(@tol, '') <> ISNULL(@dTol, '') OR ISNULL(@ig, '') <> ISNULL(@dIg, '') OR ISNULL(@statusz, 0) <> ISNULL(@dStatusz, 0)
				)
			BEGIN
				
				exec sp_kedeny_gcmsync 
					 @kedenyID, @kedenyekID, @kukauritID, @szolgID, @RFCHIPID, @szlaMod, @korrekcio, @tol, @ig, @statusz, @szelektiv,
					 @dKedenyID, @dKedenyekID, @dKukauritID, @dSzolgID, @dRFCHIPID, @dSzlaMod, @dKorrekcio, @dTol, @dIg, @dStatusz, @dSzelektiv,
					 @vevoID, @szghelyID, @varosID, @utcaID, @koztertpID, @webUserID, 0

			END

			FETCH NEXT FROM KedenyCursor INTO 
				@kedenyID, @dKedenyID, @kedenyekID, @dKedenyekID, @kukauritID, @dKukauritID, @szolgID, @dSzolgID,
				@RFCHIPID, @dRFCHIPID, @szlaMod, @dSzlaMod, @korrekcio, @dKorrekcio, @tol, @dTol, @ig, @dIg,
				@statusz, @dStatusz, @szelektiv, @dSzelektiv, @vevoID, @szghelyID, @varosID, @utcaID, @koztertpID
		END

		CLOSE KedenyCursor
		DEALLOCATE KedenyCursor

		COMMIT

	END TRY
	BEGIN CATCH
		ROLLBACK
	END CATCH

END TRY
BEGIN CATCH
END CATCH
END