CREATE TRIGGER [dbo].[tr_keszlet_modify] ON [dbo].[KESZLET] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') > 0
	RETURN

DECLARE @keszletID int, @raktarID tinyint, @cikkID int, @mennyi decimal(11,3), @foglalt decimal(10,3),

		@dKeszletID int, @dRaktarID tinyint, @dCikkID int, @dMennyi decimal(11,3), @dFoglalt decimal(10,3),

		@gcmMuvInt int, @histID int, @webreVissz bit, @webre bit, @webre2 bit

SELECT @keszletID=KeszletID, @raktarID=RaktarID, @cikkID=CikkID, @mennyi=Mennyi, @foglalt=Foglalt FROM inserted

SELECT @dKeszletID=KeszletID, @dRaktarID=RaktarID, @dCikkID=CikkID, @dMennyi=Mennyi, @dFoglalt=Foglalt FROM deleted

--j vagy mdosts
IF @keszletID IS NOT NULL
BEGIN

	--(Megsznt vagy nem webshopos raktr) 
	IF ((SELECT COUNT(*) FROM RAKTAR WHERE RaktarID = @raktarID AND (ISNULL(Megszunt,0) = 1 OR ISNULL(WebShop,0) = 0)) = 1)
		RETURN

	--nem megsznt s (webshop cikk vagy webshopra vissza)
	SELECT @webreVissz=ISNULL(WebreVissz,0), @webre=ISNULL(Webre,0), @webre2=ISNULL(Webre2,0) FROM CIKK WHERE CikkID = @cikkID AND ISNULL(Megszunt,0) = 0 AND Cikkhiercs IS NOT NULL AND (Webre = 1 OR Webre2 = 1 OR WebreVissz = 1)
	
	IF @@ROWCOUNT = 0
		RETURN

	SET @gcmMuvInt = 62 --Kszlet letlts

	--Mdosts
	IF @dKeszletID IS NOT NULL
	BEGIN

		--Flex-Fnynl a foglalt mennyisget is kszlet vltozsnak kell venni
		IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'FLEX') > 0
		BEGIN
			--ha nem vltozott az tadott rtkek valamelyike
			IF @mennyi - ISNULL(@foglalt,0) = @dMennyi - ISNULL(@dFoglalt,0)
				RETURN
		END
		ELSE
		BEGIN
			--ha nem vltozott az tadott rtkek valamelyike
			IF @mennyi = @dMennyi
				RETURN
		END
	END
END
ELSE
BEGIN
	--TODO BUG, GCMSYNC bejegyzett kszlet trlst NULL RekordID-vel 2x majd ezt kveten kszlet letlts
	RETURN

	--(Megsznt vagy nem webshopos raktr) vagy (megsznt vagy nem webshop cikk) esetn nem kell kikldeni
	IF ((SELECT COUNT(*) FROM RAKTAR WHERE RaktarID = @dRaktarID AND (ISNULL(Megszunt,0) = 1 OR ISNULL(WebShop,0) = 0)) = 1) OR ((SELECT COUNT(*) FROM CIKK WHERE CikkID = @dCikkID AND (ISNULL(Megszunt,0) = 1 OR (ISNULL(Webre,0) = 0 AND ISNULL(Webre2,0) = 0) OR Cikkhiercs IS NULL)) = 1)
		RETURN

	SET @gcmMuvInt = 63 --Kszlet trls
	SET @keszletID = @dKeszletID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	IF @webUserID <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @keszletID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 62) AND UserID = @webUserID

	IF @webUserID2 <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @keszletID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 62) AND UserID = @webUserID2
END

BEGIN TRY
	BEGIN TRAN

	--Csak ha van kszlet (Flex-Fny rendels esetn nem kell Webre-re mehet kapcsolni)
	IF @WebreVissz = 1 AND @mennyi > 0
	BEGIN
	
		UPDATE CIKK SET Webre = 1, WebreVissz = 0 WHERE CikkID = @cikkID

		INSERT INTO HISTORY (Mikor, UserID, Esemeny, Tablaid, Rekordid) VALUES (GETDATE(), @webUserID,'J',43,@cikkID)
		SET @histID=SCOPE_IDENTITY()

		--WEB-re mehet
		INSERT INTO HISTORYS (MltID, HistID, RegiTartal) VALUES (6886,@histID,0)

		--WEB-re visszatenni
		INSERT INTO HISTORYS (MltID, HistID, RegiTartal) VALUES (7389,@histID,1)
	END

	IF @webre = 1 AND @webUserID <> ''
		INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@keszletID,@webUserID)

	IF @webre2 = 1 AND @webUserID2 <> ''
		INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@keszletID,@webUserID2)

	COMMIT
END TRY
BEGIN CATCH
	ROLLBACK
END CATCH