CREATE TRIGGER [dbo].[tr_keszletp_update] ON [dbo].[KESZLETP] FOR INSERT,UPDATE
AS

--Automatikus ablak frissts
IF (SELECT UPPER(LTRIM(RTRIM(ISNULL(Ertek, '')))) FROM SETUP WHERE SetupID = 208) <> 'IGEN'
	RETURN

DECLARE @serviceName varchar(max), @keszletpID int, @keszletID int, @message varchar(6000) = N'<changes><change tableName = ''KESZLETP'' type='''

IF (SELECT COUNT(*) FROM inserted) > 0
BEGIN
	IF (SELECT COUNT(*) FROM deleted) = 0
		SET @message += 'insert'
	ELSE
		SET @message += 'update'
END
ELSE IF (SELECT COUNT(*) FROM deleted) = 0
	RETURN

SET @message += '''>'

DECLARE KeszletpCursor CURSOR FOR

	SELECT KeszletpID, KeszletID FROM inserted

OPEN KeszletpCursor

FETCH NEXT FROM KeszletpCursor INTO @keszletpID, @keszletID

WHILE @@FETCH_STATUS = 0
BEGIN
	SET @message += '<id>' + CAST(@keszletpID AS varchar) + '</id>'
	SET @message += '<keszletID>' + CAST(@keszletID AS varchar) + '</keszletID>'
	FETCH NEXT FROM KeszletpCursor INTO @keszletpID, @keszletID
END

CLOSE KeszletpCursor
DEALLOCATE KeszletpCursor

BEGIN TRANSACTION

DECLARE ServiceCursor CURSOR FOR

	SELECT name FROM sys.services WHERE name LIKE 'KristalyRowRefreshService%'

OPEN ServiceCursor

FETCH NEXT FROM ServiceCursor INTO @serviceName

WHILE @@FETCH_STATUS = 0
BEGIN

	DECLARE @NotificationDialog UNIQUEIDENTIFIER
	BEGIN DIALOG CONVERSATION @NotificationDialog
	FROM SERVICE @serviceName
	TO SERVICE @serviceName
	ON CONTRACT [http://schemas.microsoft.com/SQL/Notifications/PostQueryNotification]
	WITH ENCRYPTION = OFF;
	SEND ON CONVERSATION @NotificationDialog 
	MESSAGE TYPE [http://schemas.microsoft.com/SQL/Notifications/QueryNotification] (@message + '</change></changes>')
	END CONVERSATION @NotificationDialog WITH CLEANUP
	FETCH NEXT FROM ServiceCursor INTO @serviceName
END

CLOSE ServiceCursor
DEALLOCATE ServiceCursor

COMMIT TRANSACTION