CREATE TRIGGER [dbo].[tr_kukaurit_modify] ON [dbo].[KUKAURIT]
FOR UPDATE, DELETE
AS 
BEGIN
BEGIN TRY
	DECLARE @kukaUritID tinyint, @kukaUritNv varchar(30),
			@dKukaUritID tinyint, @dKukaUritNv varchar(30),
			@webUserID smallint

	IF DB_NAME() LIKE '%teszt%'
		RETURN

	--WEB user azonost
	SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

	IF @webUserID = ''
		RETURN

	IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') = 0
		RETURN

	IF CURSOR_STATUS('global','KukauritCursor')>=-1
	BEGIN
		CLOSE KukauritCursor
		DEALLOCATE KukauritCursor
	END

	DECLARE KukauritCursor CURSOR FOR

	SELECT inserted.KukaUritID, deleted.KukaUritID, inserted.KukaUritNv, deleted.KukaUritNv
	FROM deleted
		 LEFT JOIN inserted ON inserted.KukaUritID = deleted.KukaUritID
	     INNER JOIN KEDENY ON KEDENY.KukaUritID = deleted.KukaUritID
		 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
	WHERE KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date))
	GROUP BY inserted.KukaUritID, deleted.KukaUritID, inserted.KukaUritNv, deleted.KukaUritNv

	OPEN KukauritCursor

	BEGIN TRY
		BEGIN TRAN

		FETCH NEXT FROM KukauritCursor INTO @kukaUritID, @dKukaUritID, @kukaUritNv, @dKukaUritNv
		WHILE @@FETCH_STATUS = 0
		BEGIN
			--ha vltozott az tadott rtkek valamelyike
			IF ISNULL(@kukaUritNv, '') <> ISNULL(@dKukaUritNv, '')
			BEGIN
							UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = ISNULL(@kukaUritID,@dKukaUritID) AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = (CASE WHEN @kukaUritID IS NULL THEN 94 ELSE 95 END)) --Zrtt tenni a korbbi esemnyt
				INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = (CASE WHEN @kukaUritID IS NULL THEN 95 ELSE 94 END)), ISNULL(@kukaUritID,@dKukaUritID), @webUserID)
			END

			FETCH NEXT FROM KukauritCursor INTO @kukaUritID, @dKukaUritID, @kukaUritNv, @dKukaUritNv
		END

		CLOSE KukauritCursor
		DEALLOCATE KukauritCursor

		COMMIT

	END TRY
	BEGIN CATCH
		ROLLBACK
	END CATCH

END TRY
BEGIN CATCH
END CATCH
END