CREATE TRIGGER [dbo].[tr_rendvfej_insert] ON [dbo].[RENDVFEJ] 
FOR INSERT
AS

DECLARE @rendvfejID int, @userID smallint, @telepID tinyint, @rendvJel varchar(3), @rendvSorsz int, @rendvHossz tinyint, @evJel varchar(2)

BEGIN TRY
	SELECT @rendvfejID = RendvfejID, @userID = CreUser FROM inserted

	
	UPDATE RENDVFEJ SET Vonalkod=dbo.GenEAN(22,@rendvfejID) WHERE RendvfejID=@rendvfejID

	SET @telepID = dbo.fc_usetup(107, @userID)
	
	IF @telepID IS NULL OR @telepID = 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN
	END

	SELECT @rendvJel = RendVJel, @rendvSorsz = ISNULL(RendVSorsz, 0), @rendvHossz = RendVHossz, @evJel = EvJel FROM TELEP WHERE TelepID = @telepID

	UPDATE RENDVFEJ SET RendSzam = LTRIM(RTRIM(@rendvJel)) + '-' + @evJel + '-' + REPLACE(STR(@rendvSorsz + 1, @rendvHossz), SPACE(1), '0') WHERE Rendvfejid = @rendvfejID

	UPDATE TELEP SET RendVSorsz = @rendvSorsz + 1 WHERE TelepID = @telepID
END TRY
BEGIN CATCH
	ROLLBACK TRANSACTION
END CATCH