CREATE TRIGGER [dbo].[tr_szgkorl_update] ON [dbo].[SZGKORL]
FOR INSERT, UPDATE, DELETE
AS 
BEGIN
BEGIN TRY
	DECLARE @szghelyID int, 
	@meddig date,
	@dMeddig date,
	
	--GCM klds
	@userID smallint, @gcmMuvID int, @fogyHEllID int, @ocsereerID int

	SELECT @szghelyID = SzghelyID, @meddig = Meddig FROM inserted
	SELECT @szghelyID = SzghelyID, @dMeddig = Meddig FROM deleted

	--ha nem vltozott az tadott rtkek valamelyike
	IF ISNULL(@meddig, '') = ISNULL(@dMeddig, '')
		RETURN

	IF CURSOR_STATUS('global','SzgkorlCursor')>=-1
	BEGIN
		CLOSE SzgkorlCursor
		DEALLOCATE SzgkorlCursor
	END

	DECLARE SzgkorlCursor CURSOR FOR

	SELECT USERS.UserID, MAX(FOGYHELL.FogyHEllID) AS 'FogyHEllID', MAX(OCSEREER.OcsereerID) AS 'OcsereerID'
	FROM NAPTAR
		 INNER JOIN SZEMELY ON SZEMELY.SzemelyID = NAPTAR.SzemelyID
		 INNER JOIN USERS ON USERS.Szemelyid = SZEMELY.SzemelyID
		 LEFT JOIN OCSEREER ON OCSEREER.OcsereerID = NAPTAR.Mutato AND NAPTAR.MutatoTip = 3 AND OCSEREER.Lezarva IS NULL AND ISNULL(OCSEREER.Lezart,0) = 0
		 LEFT JOIN FOGYHELL ON FOGYHELL.FogyHEllID = NAPTAR.Mutato AND NAPTAR.MutatoTip = 2 AND FOGYHELL.Lezarva IS NULL AND ISNULL(FOGYHELL.Lezart,0) = 0
	WHERE (OCSEREER.SzghelyID = @szghelyID OR FOGYHELL.SzghelyID = @szghelyID) AND USERS.SyncInterv IS NOT NULL
	GROUP BY USERS.UserID
	
	OPEN SzgkorlCursor

	BEGIN TRY
		BEGIN TRAN

		FETCH NEXT FROM SzgkorlCursor INTO @userID, @fogyHEllID, @ocsereerID
		WHILE @@FETCH_STATUS = 0
		BEGIN

			--Ellenrzs mdosts
			IF @fogyHEllID IS NOT NULL
			BEGIN
				SELECT @gcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 6
				INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, FogyHEllID) VALUES (@gcmMuvID, @fogyHEllID, @userID, @fogyHEllID)
			END

			--racsere mdosts
			IF @ocsereerID IS NOT NULL
			BEGIN
				SELECT @gcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 9
				INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, OcsereerID) VALUES (@gcmMuvID, @ocsereerID, @userID, @ocsereerID)
			END

			FETCH NEXT FROM SzgkorlCursor INTO @userID, @fogyHEllID, @ocsereerID
		END

		CLOSE SzgkorlCursor
		DEALLOCATE SzgkorlCursor

		COMMIT

	END TRY
	BEGIN CATCH
		ROLLBACK
	END CATCH

END TRY
BEGIN CATCH
END CATCH
END