CREATE TRIGGER [dbo].[tr_szolgal_modify_kuka] ON [dbo].[SZOLGAL]
FOR UPDATE, DELETE
AS 
BEGIN
BEGIN TRY
	DECLARE @szolgID smallint, @szolgNev varchar(50), @szolgLeir varchar(200),
			@dSzolgID smallint, @dSzolgNev varchar(50), @dSzolgLeir varchar(200),
			@webUserID smallint

	IF DB_NAME() LIKE '%teszt%'
		RETURN

	--WEB user azonost
	SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

	IF @webUserID = ''
		RETURN

	IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') = 0
		RETURN

	IF CURSOR_STATUS('global','SzolgalCursor')>=-1
	BEGIN
		CLOSE SzolgalCursor
		DEALLOCATE SzolgalCursor
	END

	DECLARE SzolgalCursor CURSOR FOR

	SELECT inserted.SzolgID, deleted.SzolgID, inserted.SzolgNev, deleted.SzolgNev, inserted.SzolgLeir, deleted.SzolgLeir
	FROM deleted
		 LEFT JOIN inserted ON inserted.SzolgID = deleted.SzolgID
	     INNER JOIN KEDENY ON KEDENY.SzolgID = deleted.SzolgID
		 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
	WHERE KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date))
	GROUP BY inserted.SzolgID, deleted.SzolgID, inserted.SzolgNev, deleted.SzolgNev, inserted.SzolgLeir, deleted.SzolgLeir

	OPEN SzolgalCursor

	BEGIN TRY
		BEGIN TRAN

		FETCH NEXT FROM SzolgalCursor INTO @szolgID, @dSzolgID, @szolgNev, @dSzolgNev, @szolgLeir, @dSzolgLeir
		WHILE @@FETCH_STATUS = 0
		BEGIN
			--ha vltozott az tadott rtkek valamelyike
			IF ISNULL(@szolgNev, '') <> ISNULL(@dSzolgNev, '') OR ISNULL(@szolgLeir, '') <> ISNULL(@dSzolgLeir, '')
			BEGIN
				UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = ISNULL(@szolgID,@dSzolgID) AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = (CASE WHEN @szolgID IS NULL THEN 96 ELSE 97 END)) --Zrtt tenni a korbbi esemnyt
				INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = (CASE WHEN @szolgID IS NULL THEN 97 ELSE 96 END)), ISNULL(@szolgID,@dSzolgID), @webUserID)
			END

			FETCH NEXT FROM SzolgalCursor INTO @szolgID, @dSzolgID, @szolgNev, @dSzolgNev, @szolgLeir, @dSzolgLeir
		END

		CLOSE SzolgalCursor
		DEALLOCATE SzolgalCursor

		COMMIT

	END TRY
	BEGIN CATCH
		ROLLBACK
	END CATCH

END TRY
BEGIN CATCH
END CATCH
END