CREATE TRIGGER [dbo].[tr_szolgal_update] ON [dbo].[SZOLGAL] FOR INSERT,UPDATE,DELETE
AS

--Automatikus ablak frissts
IF (SELECT UPPER(LTRIM(RTRIM(ISNULL(Ertek, '')))) FROM SETUP WHERE SetupID = 208) <> 'IGEN'
	RETURN

DECLARE @serviceName varchar(max), @szolgID int, @message varchar(6000) = N'<changes><change tableName = ''SZOLGAL'' type='''

IF (SELECT COUNT(*) FROM inserted) > 0
BEGIN
	IF (SELECT COUNT(*) FROM deleted) = 0
		SET @message += 'insert'
	ELSE
		SET @message += 'update'
END
ELSE IF (SELECT COUNT(*) FROM deleted) > 0
	SET @message += 'delete'
ELSE
	RETURN

SET @message += '''>'

DECLARE SzolgalCursor CURSOR FOR

	SELECT SzolgID FROM inserted
	UNION
	SELECT SzolgID FROM deleted

OPEN SzolgalCursor

FETCH NEXT FROM SzolgalCursor INTO @szolgID

WHILE @@FETCH_STATUS = 0
BEGIN
	SET @message += '<id>' + CAST(@szolgID AS varchar) + '</id>'
	FETCH NEXT FROM SzolgalCursor INTO @szolgID
END

CLOSE SzolgalCursor
DEALLOCATE SzolgalCursor

BEGIN TRANSACTION

DECLARE ServiceCursor CURSOR FOR

	SELECT name FROM sys.services WHERE name LIKE 'KristalyRowRefreshService%'

OPEN ServiceCursor

FETCH NEXT FROM ServiceCursor INTO @serviceName

WHILE @@FETCH_STATUS = 0
BEGIN

	DECLARE @NotificationDialog UNIQUEIDENTIFIER
	BEGIN DIALOG CONVERSATION @NotificationDialog
	FROM SERVICE @serviceName
	TO SERVICE @serviceName
	ON CONTRACT [http://schemas.microsoft.com/SQL/Notifications/PostQueryNotification]
	WITH ENCRYPTION = OFF;
	SEND ON CONVERSATION @NotificationDialog 
	MESSAGE TYPE [http://schemas.microsoft.com/SQL/Notifications/QueryNotification] (@message + '</change></changes>')
	END CONVERSATION @NotificationDialog WITH CLEANUP
	FETCH NEXT FROM ServiceCursor INTO @serviceName
END

CLOSE ServiceCursor
DEALLOCATE ServiceCursor

COMMIT TRANSACTION