CREATE TRIGGER [dbo].[tr_utcak_modify_kuka] ON [dbo].[UTCAK]
FOR UPDATE, DELETE
AS 
BEGIN
BEGIN TRY
	DECLARE @utcaID smallint, @csakNev varchar(40), @koztertpID smallint,
			@dUtcaID smallint, @dCsakNev varchar(40), @dKoztertpID smallint,
			@webUserID smallint, @gcmMuvID int, @szghelyGcmMuvID int

	--WEB user azonost
	SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

	IF @webUserID = ''
		RETURN

	IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') = 0
		RETURN
	
	IF CURSOR_STATUS('global','UtcaCursor')>=-1
	BEGIN
		CLOSE UtcaCursor
		DEALLOCATE UtcaCursor
	END

	DECLARE UtcaCursor CURSOR FOR

	SELECT inserted.UtcaID, deleted.UtcaID, inserted.CsakNev, deleted.CsakNev, inserted.KoztertpID, deleted.KoztertpID
	FROM deleted
		 LEFT JOIN inserted ON inserted.UtcaID = deleted.UtcaID
		 INNER JOIN SZGHELY ON ISNULL(SZGHELY.UrUtcaID, SZGHELY.SzgUtcaID) = deleted.UtcaID
	     INNER JOIN KEDENY ON KEDENY.SzghelyID = SZGHELY.SzghelyID
		 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
	WHERE KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date))
	GROUP BY inserted.UtcaID, deleted.UtcaID, inserted.CsakNev, deleted.CsakNev, inserted.KoztertpID, deleted.KoztertpID

	OPEN UtcaCursor

	BEGIN TRY
		BEGIN TRAN

		FETCH NEXT FROM UtcaCursor INTO @utcaID, @dUtcaID, @csakNev, @dCsakNev, @koztertpID, @dKoztertpID
		WHILE @@FETCH_STATUS = 0
		BEGIN

			IF @gcmMuvID IS NULL
				SELECT @gcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = (CASE WHEN @utcaID IS NULL THEN 73 ELSE 72 END) --73: Utca trls, 72: Utca mdosts

			--ha vltozott az tadott rtkek valamelyike
			IF ISNULL(@csakNev, '') <> ISNULL(@dCsakNev, '') OR ISNULL(@koztertpID, 0) <> ISNULL(@dKoztertpID, 0)
			BEGIN
				INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES (@gcmMuvID, ISNULL(@utcaID,@dUtcaID), @webUserID)

				IF @szghelyGcmMuvID IS NULL
					SELECT @szghelyGcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 16 --16: Szolgltatsi hely mdosts

				INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID)
				SELECT @szghelyGcmMuvID, SZGHELY.SzghelyID, @webUserID
				FROM SZGHELY
					 INNER JOIN KEDENY ON KEDENY.SzghelyID = SZGHELY.SzghelyID
					 INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
				WHERE KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date)) AND SZGHELY.SzgUtcaID = ISNULL(@utcaID,@dUtcaID)

			END

			FETCH NEXT FROM UtcaCursor INTO @utcaID, @dUtcaID, @csakNev, @dCsakNev, @koztertpID, @dKoztertpID
		END

		CLOSE UtcaCursor
		DEALLOCATE UtcaCursor

		COMMIT

	END TRY
	BEGIN CATCH
		ROLLBACK
	END CATCH

END TRY
BEGIN CATCH
END CATCH
END