CREATE TRIGGER [dbo].[tr_vevo_modify_kuka] ON [dbo].[VEVO]
FOR UPDATE, DELETE
AS 
BEGIN
BEGIN TRY
	DECLARE @vevoID int, @vevoNev varchar(40), 
			@dVevoID int, @dVevoNev varchar(40), 
			@webUserID smallint

	IF DB_NAME() LIKE '%teszt%'
		RETURN

	--WEB user azonost
	SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

	IF @webUserID = ''
		RETURN

	IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') = 0
		RETURN

	IF CURSOR_STATUS('global','VevoCursor')>=-1
	BEGIN
		CLOSE VevoCursor
		DEALLOCATE VevoCursor
	END

	DECLARE VevoCursor CURSOR FOR

	SELECT inserted.VevoID, deleted.VevoID, inserted.VevoNev, deleted.VevoNev
	FROM deleted
		 LEFT JOIN inserted ON inserted.VevoID = deleted.VevoID
	     INNER JOIN SZGHELY ON SZGHELY.VevoID = deleted.VevoID
	     INNER JOIN KEDENY ON KEDENY.SzghelyiD = SZGHELY.SzghelyID
	     INNER JOIN KEDENYEK ON KEDENYEK.KedenyekID = KEDENY.Kedenyekid
	WHERE KEDENY.SzolgID IS NOT NULL AND KEDENY.Statusz = 1 AND ISNULL(KEDENYEK.Szelektiv,0) = 0 AND KEDENY.Tol <= CAST(GETDATE() AS date) AND (KEDENY.Ig IS NULL OR KEDENY.Ig >= CAST(GETDATE() AS date))
	GROUP BY inserted.VevoID, deleted.VevoID, inserted.VevoNev, deleted.VevoNev

	OPEN VevoCursor

	BEGIN TRY
		BEGIN TRAN

		FETCH NEXT FROM VevoCursor INTO @vevoID, @dVevoID, @vevoNev, @dVevoNev
		WHILE @@FETCH_STATUS = 0
		BEGIN
			--ha vltozott az tadott rtkek valamelyike
			IF ISNULL(@vevoNev, '') <> ISNULL(@dVevoNev, '')
			BEGIN
				UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = ISNULL(@vevoID,@dVevoID) AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = (CASE WHEN @vevoID IS NULL THEN 17 ELSE 88 END)) --Zrtt tenni a korbbi esemnyt
				INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = (CASE WHEN @vevoID IS NULL THEN 88 ELSE 17 END)), ISNULL(@vevoID,@dVevoID), @webUserID)
			END

			FETCH NEXT FROM VevoCursor INTO @vevoID, @dVevoID, @vevoNev, @dVevoNev
		END

		CLOSE VevoCursor
		DEALLOCATE VevoCursor

		COMMIT

	END TRY
	BEGIN CATCH
		ROLLBACK
	END CATCH

END TRY
BEGIN CATCH
END CATCH
END