CREATE TRIGGER [dbo].[tr_vevokpcs_update] ON [dbo].[VEVOKPCS]
FOR INSERT, UPDATE, DELETE
AS 
BEGIN
BEGIN TRY
	DECLARE @vevoID int, 
	@vevokpcsID int, @kapcsTip tinyint, @kapcsErtek varchar(50), @kapcsHozza varchar(40),
	@dVevokpcsID int, @dKapcsTip tinyint, @dKapcsErtek varchar(50), @dKapcsHozza varchar(40),
	
	--GCM klds
	@userID smallint, @gcmMuvID int, @gcmMuvInt int, @csomagID int, @fogyHEllID int, @ocsereerID int

	SELECT @vevokpcsID = VevokpcsID, @kapcsTip = KapcsTip, @vevoID = VevoID, @kapcsErtek = KapcsErtek, @kapcsHozza = KapcsHozza FROM inserted
	SELECT @dvevokpcsID = VevokpcsID, @dKapcsTip = KapcsTip, @vevoID = VevoID, @dKapcsErtek = KapcsErtek, @dKapcsHozza = KapcsHozza FROM deleted

	--Webshop szlltsi cm
	IF @kapcsTip = 8 OR @dKapcsTip = 8
	BEGIN
		DECLARE @vevoresID int

		--Mdosts
		IF @vevokpcsID IS NOT NULL AND @dvevokpcsID IS NOT NULL
		BEGIN
			DECLARE @rendben bit

			SELECT @vevoresID = VevoresID, @rendben = Rendben FROM VEVORES WHERE VevokpcsID = @vevokpcsID

			--Webshop szlltsi cm
			IF @vevoresID IS NOT NULL AND @rendben = 0
				UPDATE VEVORES SET Rendben = 1 WHERE VevoresID = @vevoresID

			RETURN
		END
		--j
		ELSE IF @vevokpcsID IS NOT NULL AND @dVevokpcsID IS NULL
		BEGIN
			DECLARE @vevoRegID int, @orszagNev varchar(40), @varosIrsz varchar(10), @varosNev varchar(40), @csakNev varchar(40), @koztertpNv varchar(15), @cimkod varchar(21), @kapcsNev varchar(50)
			SELECT @vevoRegID = VevoregID FROM VEVOREG WHERE VevoID = @vevoID

			--Ha WebShop vev
			IF @vevoRegID IS NOT NULL
			BEGIN
				SELECT @orszagNev = ORSZAG.OrszagNev, @varosIrsz = VAROSOK.VarosIrsz, @varosNev = VAROSOK.VarosNev, @csakNev = UTCAK.CsakNev, @koztertpNv = KOZTERTP.KoztertpNv, @cimkod = inserted.cimkod, @kapcsNev = inserted.KapcsNev
				FROM inserted
					 LEFT JOIN VAROSOK ON VAROSOK.VarosID = inserted.VarosID
					 LEFT JOIN ORSZAG ON ORSZAG.OrszagID = VAROSOK.OrszagID
					 LEFT JOIN UTCAK ON UTCAK.UtcaID = inserted.UtcaID
					 LEFT JOIN KOZTERTP ON KOZTERTP.KoztertpID = UTCAK.KoztertpID

				INSERT INTO VEVORES (VevoRegID,SzOrszag,SzIrsz,SzVaros,SzUtcaNev,
									 SzKozter,SzHsz,VevokpcsID,Rendben,Kapcsnev)
							 VALUES (@vevoRegID,@orszagNev,@varosIrsz,@varosNev,@csakNev,
									 @koztertpNv,@cimkod,@vevokpcsID,1,@kapcsNev)
			END
		END
		--Trls
		ELSE
		BEGIN
			SELECT @vevoResID = VevoresID FROM VEVORES WHERE VevokpcsID = @dVevokpcsID

			--Ha van WebShop szlltsi cm
			IF @vevoResID IS NOT NULL
			BEGIN
				DELETE FROM VEVORES WHERE VevoresID = @vevoResID
			END
		END
	END

	--ha nem telefon s nem mobiltelefon
	IF @vevokpcsID IS NOT NULL
	BEGIN
		IF @kapcsTip NOT IN(1,2)
			RETURN
	END
	ELSE
	BEGIN
		IF @dKapcsTip NOT IN(1,2)
			RETURN
	END

       if  @kapcsTip=1		
			update vevo set vevtel1ID=@vevokpcsID where vevoid=@vevoid
       if  @kapcsTip=2		
			update vevo set vevtel2ID=@vevokpcsID where vevoid=@vevoid
   
	--ha nem vltozott az tadott rtkek valamelyike
	IF ISNULL(@kapcsErtek, '') = ISNULL(@dKapcsErtek, '') AND ISNULL(@kapcsHozza, 0) = ISNULL(@dKapcsHozza, 0)
		RETURN

     

	IF CURSOR_STATUS('global','VevokpcsCursor')>=-1
	BEGIN
		CLOSE VevokpcsCursor
		DEALLOCATE VevokpcsCursor
	END

	DECLARE VevokpcsCursor CURSOR FOR

	SELECT L.UserID, MAX(L.CsomagID) AS 'CsomagID', MAX(L.FogyHEllID) AS 'FogyHEllID', MAX(L.OcsereerID) AS 'OcsereerID' FROM (
	SELECT ISNULL(leolvast.UserIDt, LEOLVASO.UserID) AS 'UserID', MAX(OLVASCSM.CsomagID) AS 'CsomagID', NULL AS 'FogyHEllID', NULL AS 'OcsereerID'
	FROM FOHELY
		 INNER JOIN SZGHELY ON SZGHELY.SzghelyID = FOHELY.SzghelyID
		 JOIN OLVASCSM ON
					(CASE WHEN OLVASCSM.LeolvasoID IS NULL AND OLVASCSM.Leolvas2ID IS NULL THEN 0 ELSE ISNULL(SZGHELY.Leolvaso, 0) END IN (ISNULL(OLVASCSM.LeolvasoID, 0), ISNULL(OLVASCSM.Leolvas2ID, 0))) AND
					(CASE WHEN OLVASCSM.SzgcsopID IS NULL AND OLVASCSM.SzgCsopID2 IS NULL THEN 0 ELSE SZGHELY.SzgCsopID END IN (ISNULL(OLVASCSM.SzgcsopID, 0), ISNULL(OLVASCSM.SzgCsopID2, 0))) AND
					(CASE WHEN OLVASCSM.SzlaciklID IS NULL AND OLVASCSM.Szlacikli2 IS NULL THEN 0 ELSE SZGHELY.SzlaCiklID END IN (ISNULL(OLVASCSM.SzlaciklID, 0), ISNULL(OLVASCSM.Szlacikli2, 0))) AND
					(CASE WHEN OLVASCSM.Varosid IS NULL AND OLVASCSM.VarosID2 IS NULL THEN 0 ELSE ISNULL(SZGHELY.SzgVarosID, 0) END IN (ISNULL(OLVASCSM.Varosid, 0), ISNULL(OLVASCSM.VarosID2, 0))) AND
					(CASE WHEN OLVASCSM.utcaid IS NULL THEN 0 ELSE ISNULL(SZGHELY.SzgUtcaID, 0) END = ISNULL(OLVASCSM.utcaid, 0))
		INNER JOIN LEOLVASO ON LEOLVASO.LeolvasoID = OLVASCSM.LeolvasoID
		INNER JOIN USERS ON USERS.UserID = LEOLVASO.Userid
		LEFT JOIN leolvast ON leolvast.leolvastID = OLVASCSM.Munkavegzo
	WHERE SZGHELY.VevoID = @vevoID AND FOHELY.Ig IS NULL AND FOHELY.Mero <> 1 AND LEOLVASO.PsionTip = 'A' AND OLVASCSM.Psionba IS NOT NULL AND OLVASCSM.Psionbol IS NULL AND OLVASCSM.Kartonra IS NULL
	GROUP BY ISNULL(leolvast.UserIDt, LEOLVASO.UserID)

	UNION

	SELECT USERS.UserID, NULL AS 'CsomagID', MAX(FOGYHELL.FogyHEllID) AS 'FogyHEllID', MAX(OCSEREER.OcsereerID) AS 'OcsereerID'
	FROM NAPTAR
		 INNER JOIN SZEMELY ON SZEMELY.SzemelyID = NAPTAR.SzemelyID
		 INNER JOIN USERS ON USERS.Szemelyid = SZEMELY.SzemelyID
		 LEFT JOIN OCSEREER ON OCSEREER.OcsereerID = NAPTAR.Mutato AND NAPTAR.MutatoTip = 3 AND OCSEREER.Lezarva IS NULL AND ISNULL(OCSEREER.Lezart,0) = 0
		 LEFT JOIN SZGHELY SZGHELY_OCSEREER ON SZGHELY_OCSEREER.SzghelyID = OCSEREER.SzghelyID
		 LEFT JOIN FOGYHELL ON FOGYHELL.FogyHEllID = NAPTAR.Mutato AND NAPTAR.MutatoTip = 2 AND FOGYHELL.Lezarva IS NULL AND ISNULL(FOGYHELL.Lezart,0) = 0
		 LEFT JOIN SZGHELY SZGHELY_FOGYHELL ON SZGHELY_FOGYHELL.SzghelyID = FOGYHELL.SzghelyID
	WHERE (SZGHELY_OCSEREER.VevoID = @vevoID OR SZGHELY_FOGYHELL.VevoID = @vevoID) AND USERS.SyncInterv IS NOT NULL
	GROUP BY USERS.UserID) L
	GROUP BY L.UserID
	
	OPEN VevokpcsCursor

	BEGIN TRY
		BEGIN TRAN

		IF @vevokpcsID IS NOT NULL
		BEGIN
			IF @dVevokpcsID IS NULL
				SET @gcmMuvInt = 11 --j vev elrhetsg
			ELSE
				SET @gcmMuvInt = 12 --Vev elrhetsg mdosts
		END
		ELSE
		BEGIN
			SET @gcmMuvInt = 13 --Vev elrhetsg trls
			SET @vevokpcsID = @dVevokpcsID

			-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
			UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @vevokpcsID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt IN (11,12))
		END

		SELECT @gcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt

		FETCH NEXT FROM VevokpcsCursor INTO @userID, @csomagID, @fogyHEllID, @ocsereerID
		WHILE @@FETCH_STATUS = 0
		BEGIN

			INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, CsomagID, FogyHEllID, OcsereerID) VALUES (@gcmMuvID, @vevokpcsID, @userID, @csomagID, @fogyHEllID, @ocsereerID)

			FETCH NEXT FROM VevokpcsCursor INTO @userID, @csomagID, @fogyHEllID, @ocsereerID
		END

		CLOSE VevokpcsCursor
		DEALLOCATE VevokpcsCursor

		COMMIT

	END TRY
	BEGIN CATCH
		ROLLBACK
	END CATCH

END TRY
BEGIN CATCH
END CATCH
END