CREATE TRIGGER [dbo].[tr_villfogy_update] ON [dbo].[VILLFOGY]
FOR INSERT, UPDATE, DELETE
AS 
BEGIN
BEGIN TRY
	DECLARE @villfogyID smallint, @villGyari varchar(25), @megnevezes varchar(40), @villVaros smallint, @villCim varchar(30), @latti numeric(10,6), @longi numeric(10,6), @meroTipus char,
	@dVillfogyID smallint, @dVillGyari varchar(25), @dMegnevezes varchar(40), @dVillVaros smallint, @dVillCim varchar(30), @dLatti numeric(10,6), @dLongi numeric(10,6), @dMeroTipus char,

	--GCM klds
	@userID smallint, @gcmMuvID int, @gcmMuvInt int

	SELECT @villfogyID = VillfogyID, @villGyari = VillGyari, @megnevezes = Megnevezes, @villVaros = VillVaros, @villCim = VillCim, @latti = Latti, @longi = Longi, @meroTipus = MeroTipus FROM inserted
	SELECT @dVillfogyID = VillfogyID, @dVillGyari = VillGyari, @dMegnevezes = Megnevezes, @dVillVaros = VillVaros, @dVillCim = VillCim, @dLatti = Latti, @dLongi = Longi, @dMeroTipus = MeroTipus FROM deleted

	--ha nem vltozott az tadott rtkek valamelyike
	IF ISNULL(@villGyari, '') = ISNULL(@dVillGyari, '') AND ISNULL(@megnevezes, '') = ISNULL(@dMegnevezes, '') AND ISNULL(@villVaros, 0) = ISNULL(@dVillVaros, 0) AND ISNULL(@villCim, '') = ISNULL(@dVillCim, '') AND ISNULL(@latti, 0) = ISNULL(@dLatti, 0) AND ISNULL(@longi, 0) = ISNULL(@dLongi, 0) AND ISNULL(@meroTipus, '') = ISNULL(@dMeroTipus, '') 
		RETURN

	IF CURSOR_STATUS('global','VillfogyCursor')>=-1
	BEGIN
		CLOSE VillfogyCursor
		DEALLOCATE VillfogyCursor
	END

	DECLARE VillfogyCursor CURSOR FOR

	SELECT DISTINCT LEOLVASO.Userid FROM LEOLVASO
		   LEFT JOIN VILLFOGY ON LEOLVASO.LeolvasoID = VILLFOGY.LeolvasoID
		   LEFT JOIN VIZMUVEK ON LEOLVASO.LeolvasoID = VIZMUVEK.Leolvaso
	WHERE LEOLVASO.Userid IS NOT NULL AND (VILLFOGY.VillfogyID IS NOT NULL OR VIZMUVEK.VizmuvekID IS NOT NULL)

	OPEN VillfogyCursor

	IF @villfogyID IS NOT NULL
	BEGIN
		IF @dVillfogyID IS NULL
			SET @gcmMuvInt = 18 --j villamos fogyaszthely
		ELSE
			SET @gcmMuvInt = 19 --Villamos fogyaszthely mdosts
	END
	ELSE
	BEGIN
		SET @gcmMuvInt = 20 --Villamos fogyaszthely trls
		SET @villfogyID = @dVillfogyID

		-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @villfogyID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt IN (18,19))
	END

	SELECT @gcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt

	BEGIN TRY
	BEGIN TRAN

		FETCH NEXT FROM VillfogyCursor INTO @userID
		WHILE @@FETCH_STATUS = 0
		BEGIN

			INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES (@gcmMuvID, @villfogyID, @userID)

			FETCH NEXT FROM VillfogyCursor INTO @userID
		END

		CLOSE VillfogyCursor
		DEALLOCATE VillfogyCursor

		COMMIT

	END TRY
	BEGIN CATCH
		ROLLBACK
	END CATCH
END TRY
BEGIN CATCH
END CATCH
END