CREATE VIEW dbo.futesell AS
SELECT L.Sorszam, L.FohelyHID, L.SzghelyID, L.Ev, L.Futeskezd, L.FutesVeg, L.ElolegKezd, L.Fogyasztas
FROM (
	SELECT ROW_NUMBER() OVER (ORDER BY SZGHELY.RegiKod, FULLIDENY.FutesKezd, FULLIDENY.FutesVeg) AS 'Sorszam', FOHELYH.FohelyHID, SZGHELY.SzghelyID, SZGHELY.RegiKod, SZGHELY.SzgCim, ISNULL(EVEK.Ev, YEAR(FULLIDENY.FutesVeg)) AS 'Ev', FULLIDENY.FutesKezd, FULLIDENY.FutesVeg, FULLIDENY.ElolegKezd, SUM(OLVASH.Fogyasztas) AS 'Fogyasztas'
	FROM OLVASH
		 LEFT JOIN FOHELYH ON OLVASH.FohelyHID = FOHELYH.FohelyHID 
		 LEFT JOIN SZGHELY ON FOHELYH.Szghelyid = SZGHELY.SzghelyID
		 LEFT JOIN (SELECT EvekID, MIN(FutesKezd) AS 'Futeskezd', MAX(FutesVeg) AS 'FutesVeg', MIN(ElolegKezd) AS 'ElolegKezd' FROM IDENY GROUP BY EvekID) FULLIDENY ON OLVASH.Kelt BETWEEN FULLIDENY.FutesKezd AND FULLIDENY.FutesVeg
		 LEFT JOIN EVEK ON EVEK.EvekID = FULLIDENY.EvekID
	WHERE FOHELYH.Hokozpont = 1
	GROUP BY FOHELYH.FohelyHID, SZGHELY.SzghelyID, SZGHELY.RegiKod, SZGHELY.SzgCim, ISNULL(EVEK.Ev, YEAR(FULLIDENY.FutesVeg)), FULLIDENY.FutesKezd, FULLIDENY.FutesVeg, FULLIDENY.ElolegKezd) L